/**
 * @license
 * Copyright The Closure Library Authors.
 * SPDX-License-Identifier: Apache-2.0
 */
/**
 * @fileoverview Number formatting symbols.
 *
 * File generated from CLDR ver. 42
 *
 * This file covers those locales that are not covered in
 * "numberformatsymbols.js".
 *
 * @suppress {const,missingRequire,useOfGoogProvide} Suppress "missing require"
 *     warnings for names like goog.i18n.NumberFormatSymbols_af.
 *     They are included by requiring goog.i18n.NumberFormatSymbols.
 */

// clang-format off

goog.provide('goog.i18n.NumberFormatSymbolsExt');
goog.provide('goog.i18n.NumberFormatSymbols_af_NA');
goog.provide('goog.i18n.NumberFormatSymbols_af_ZA');
goog.provide('goog.i18n.NumberFormatSymbols_agq');
goog.provide('goog.i18n.NumberFormatSymbols_agq_CM');
goog.provide('goog.i18n.NumberFormatSymbols_ak');
goog.provide('goog.i18n.NumberFormatSymbols_ak_GH');
goog.provide('goog.i18n.NumberFormatSymbols_am_ET');
goog.provide('goog.i18n.NumberFormatSymbols_ar_001');
goog.provide('goog.i18n.NumberFormatSymbols_ar_AE');
goog.provide('goog.i18n.NumberFormatSymbols_ar_BH');
goog.provide('goog.i18n.NumberFormatSymbols_ar_BH_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_DJ');
goog.provide('goog.i18n.NumberFormatSymbols_ar_DJ_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_EH');
goog.provide('goog.i18n.NumberFormatSymbols_ar_ER');
goog.provide('goog.i18n.NumberFormatSymbols_ar_ER_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_IL');
goog.provide('goog.i18n.NumberFormatSymbols_ar_IL_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_IQ');
goog.provide('goog.i18n.NumberFormatSymbols_ar_IQ_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_JO');
goog.provide('goog.i18n.NumberFormatSymbols_ar_JO_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_KM');
goog.provide('goog.i18n.NumberFormatSymbols_ar_KM_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_KW');
goog.provide('goog.i18n.NumberFormatSymbols_ar_KW_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_LB');
goog.provide('goog.i18n.NumberFormatSymbols_ar_LB_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_LY');
goog.provide('goog.i18n.NumberFormatSymbols_ar_MA');
goog.provide('goog.i18n.NumberFormatSymbols_ar_MR');
goog.provide('goog.i18n.NumberFormatSymbols_ar_MR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_OM');
goog.provide('goog.i18n.NumberFormatSymbols_ar_OM_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_PS');
goog.provide('goog.i18n.NumberFormatSymbols_ar_PS_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_QA');
goog.provide('goog.i18n.NumberFormatSymbols_ar_QA_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SA');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SA_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SD');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SD_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SO');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SO_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SS');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SS_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SY');
goog.provide('goog.i18n.NumberFormatSymbols_ar_SY_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_TD');
goog.provide('goog.i18n.NumberFormatSymbols_ar_TD_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ar_TN');
goog.provide('goog.i18n.NumberFormatSymbols_ar_XB');
goog.provide('goog.i18n.NumberFormatSymbols_ar_YE');
goog.provide('goog.i18n.NumberFormatSymbols_ar_YE_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_as');
goog.provide('goog.i18n.NumberFormatSymbols_as_IN');
goog.provide('goog.i18n.NumberFormatSymbols_as_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_as_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_asa');
goog.provide('goog.i18n.NumberFormatSymbols_asa_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_ast');
goog.provide('goog.i18n.NumberFormatSymbols_ast_ES');
goog.provide('goog.i18n.NumberFormatSymbols_az_Cyrl');
goog.provide('goog.i18n.NumberFormatSymbols_az_Cyrl_AZ');
goog.provide('goog.i18n.NumberFormatSymbols_az_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_az_Latn_AZ');
goog.provide('goog.i18n.NumberFormatSymbols_bas');
goog.provide('goog.i18n.NumberFormatSymbols_bas_CM');
goog.provide('goog.i18n.NumberFormatSymbols_be_BY');
goog.provide('goog.i18n.NumberFormatSymbols_bem');
goog.provide('goog.i18n.NumberFormatSymbols_bem_ZM');
goog.provide('goog.i18n.NumberFormatSymbols_bez');
goog.provide('goog.i18n.NumberFormatSymbols_bez_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_bg_BG');
goog.provide('goog.i18n.NumberFormatSymbols_bgc');
goog.provide('goog.i18n.NumberFormatSymbols_bgc_IN');
goog.provide('goog.i18n.NumberFormatSymbols_bgc_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_bgc_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_bho');
goog.provide('goog.i18n.NumberFormatSymbols_bho_IN');
goog.provide('goog.i18n.NumberFormatSymbols_bho_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_bho_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_bm');
goog.provide('goog.i18n.NumberFormatSymbols_bm_ML');
goog.provide('goog.i18n.NumberFormatSymbols_bn_BD');
goog.provide('goog.i18n.NumberFormatSymbols_bn_BD_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_bn_IN');
goog.provide('goog.i18n.NumberFormatSymbols_bn_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_bo');
goog.provide('goog.i18n.NumberFormatSymbols_bo_CN');
goog.provide('goog.i18n.NumberFormatSymbols_bo_IN');
goog.provide('goog.i18n.NumberFormatSymbols_br_FR');
goog.provide('goog.i18n.NumberFormatSymbols_brx');
goog.provide('goog.i18n.NumberFormatSymbols_brx_IN');
goog.provide('goog.i18n.NumberFormatSymbols_bs_Cyrl');
goog.provide('goog.i18n.NumberFormatSymbols_bs_Cyrl_BA');
goog.provide('goog.i18n.NumberFormatSymbols_bs_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_bs_Latn_BA');
goog.provide('goog.i18n.NumberFormatSymbols_ca_AD');
goog.provide('goog.i18n.NumberFormatSymbols_ca_ES');
goog.provide('goog.i18n.NumberFormatSymbols_ca_FR');
goog.provide('goog.i18n.NumberFormatSymbols_ca_IT');
goog.provide('goog.i18n.NumberFormatSymbols_ccp');
goog.provide('goog.i18n.NumberFormatSymbols_ccp_BD');
goog.provide('goog.i18n.NumberFormatSymbols_ccp_BD_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ccp_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ccp_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ccp_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ce');
goog.provide('goog.i18n.NumberFormatSymbols_ce_RU');
goog.provide('goog.i18n.NumberFormatSymbols_ceb');
goog.provide('goog.i18n.NumberFormatSymbols_ceb_PH');
goog.provide('goog.i18n.NumberFormatSymbols_cgg');
goog.provide('goog.i18n.NumberFormatSymbols_cgg_UG');
goog.provide('goog.i18n.NumberFormatSymbols_chr_US');
goog.provide('goog.i18n.NumberFormatSymbols_ckb');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_Arab');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_Arab_IQ');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_Arab_IQ_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_Arab_IR');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_Arab_IR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_Arab_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_IQ');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_IQ_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_IR');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_IR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ckb_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_cs_CZ');
goog.provide('goog.i18n.NumberFormatSymbols_cv');
goog.provide('goog.i18n.NumberFormatSymbols_cv_RU');
goog.provide('goog.i18n.NumberFormatSymbols_cy_GB');
goog.provide('goog.i18n.NumberFormatSymbols_da_DK');
goog.provide('goog.i18n.NumberFormatSymbols_da_GL');
goog.provide('goog.i18n.NumberFormatSymbols_dav');
goog.provide('goog.i18n.NumberFormatSymbols_dav_KE');
goog.provide('goog.i18n.NumberFormatSymbols_de_BE');
goog.provide('goog.i18n.NumberFormatSymbols_de_DE');
goog.provide('goog.i18n.NumberFormatSymbols_de_IT');
goog.provide('goog.i18n.NumberFormatSymbols_de_LI');
goog.provide('goog.i18n.NumberFormatSymbols_de_LU');
goog.provide('goog.i18n.NumberFormatSymbols_dje');
goog.provide('goog.i18n.NumberFormatSymbols_dje_NE');
goog.provide('goog.i18n.NumberFormatSymbols_doi');
goog.provide('goog.i18n.NumberFormatSymbols_doi_IN');
goog.provide('goog.i18n.NumberFormatSymbols_dsb');
goog.provide('goog.i18n.NumberFormatSymbols_dsb_DE');
goog.provide('goog.i18n.NumberFormatSymbols_dua');
goog.provide('goog.i18n.NumberFormatSymbols_dua_CM');
goog.provide('goog.i18n.NumberFormatSymbols_dyo');
goog.provide('goog.i18n.NumberFormatSymbols_dyo_SN');
goog.provide('goog.i18n.NumberFormatSymbols_dz');
goog.provide('goog.i18n.NumberFormatSymbols_dz_BT');
goog.provide('goog.i18n.NumberFormatSymbols_dz_BT_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_dz_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ebu');
goog.provide('goog.i18n.NumberFormatSymbols_ebu_KE');
goog.provide('goog.i18n.NumberFormatSymbols_ee');
goog.provide('goog.i18n.NumberFormatSymbols_ee_GH');
goog.provide('goog.i18n.NumberFormatSymbols_ee_TG');
goog.provide('goog.i18n.NumberFormatSymbols_el_CY');
goog.provide('goog.i18n.NumberFormatSymbols_el_GR');
goog.provide('goog.i18n.NumberFormatSymbols_en_001');
goog.provide('goog.i18n.NumberFormatSymbols_en_150');
goog.provide('goog.i18n.NumberFormatSymbols_en_AE');
goog.provide('goog.i18n.NumberFormatSymbols_en_AG');
goog.provide('goog.i18n.NumberFormatSymbols_en_AI');
goog.provide('goog.i18n.NumberFormatSymbols_en_AS');
goog.provide('goog.i18n.NumberFormatSymbols_en_AT');
goog.provide('goog.i18n.NumberFormatSymbols_en_BB');
goog.provide('goog.i18n.NumberFormatSymbols_en_BE');
goog.provide('goog.i18n.NumberFormatSymbols_en_BI');
goog.provide('goog.i18n.NumberFormatSymbols_en_BM');
goog.provide('goog.i18n.NumberFormatSymbols_en_BS');
goog.provide('goog.i18n.NumberFormatSymbols_en_BW');
goog.provide('goog.i18n.NumberFormatSymbols_en_BZ');
goog.provide('goog.i18n.NumberFormatSymbols_en_CC');
goog.provide('goog.i18n.NumberFormatSymbols_en_CH');
goog.provide('goog.i18n.NumberFormatSymbols_en_CK');
goog.provide('goog.i18n.NumberFormatSymbols_en_CM');
goog.provide('goog.i18n.NumberFormatSymbols_en_CX');
goog.provide('goog.i18n.NumberFormatSymbols_en_CY');
goog.provide('goog.i18n.NumberFormatSymbols_en_DE');
goog.provide('goog.i18n.NumberFormatSymbols_en_DG');
goog.provide('goog.i18n.NumberFormatSymbols_en_DK');
goog.provide('goog.i18n.NumberFormatSymbols_en_DM');
goog.provide('goog.i18n.NumberFormatSymbols_en_ER');
goog.provide('goog.i18n.NumberFormatSymbols_en_FI');
goog.provide('goog.i18n.NumberFormatSymbols_en_FJ');
goog.provide('goog.i18n.NumberFormatSymbols_en_FK');
goog.provide('goog.i18n.NumberFormatSymbols_en_FM');
goog.provide('goog.i18n.NumberFormatSymbols_en_GD');
goog.provide('goog.i18n.NumberFormatSymbols_en_GG');
goog.provide('goog.i18n.NumberFormatSymbols_en_GH');
goog.provide('goog.i18n.NumberFormatSymbols_en_GI');
goog.provide('goog.i18n.NumberFormatSymbols_en_GM');
goog.provide('goog.i18n.NumberFormatSymbols_en_GU');
goog.provide('goog.i18n.NumberFormatSymbols_en_GY');
goog.provide('goog.i18n.NumberFormatSymbols_en_HK');
goog.provide('goog.i18n.NumberFormatSymbols_en_IL');
goog.provide('goog.i18n.NumberFormatSymbols_en_IM');
goog.provide('goog.i18n.NumberFormatSymbols_en_IO');
goog.provide('goog.i18n.NumberFormatSymbols_en_JE');
goog.provide('goog.i18n.NumberFormatSymbols_en_JM');
goog.provide('goog.i18n.NumberFormatSymbols_en_KE');
goog.provide('goog.i18n.NumberFormatSymbols_en_KI');
goog.provide('goog.i18n.NumberFormatSymbols_en_KN');
goog.provide('goog.i18n.NumberFormatSymbols_en_KY');
goog.provide('goog.i18n.NumberFormatSymbols_en_LC');
goog.provide('goog.i18n.NumberFormatSymbols_en_LR');
goog.provide('goog.i18n.NumberFormatSymbols_en_LS');
goog.provide('goog.i18n.NumberFormatSymbols_en_MG');
goog.provide('goog.i18n.NumberFormatSymbols_en_MH');
goog.provide('goog.i18n.NumberFormatSymbols_en_MO');
goog.provide('goog.i18n.NumberFormatSymbols_en_MP');
goog.provide('goog.i18n.NumberFormatSymbols_en_MS');
goog.provide('goog.i18n.NumberFormatSymbols_en_MT');
goog.provide('goog.i18n.NumberFormatSymbols_en_MU');
goog.provide('goog.i18n.NumberFormatSymbols_en_MV');
goog.provide('goog.i18n.NumberFormatSymbols_en_MW');
goog.provide('goog.i18n.NumberFormatSymbols_en_MY');
goog.provide('goog.i18n.NumberFormatSymbols_en_NA');
goog.provide('goog.i18n.NumberFormatSymbols_en_NF');
goog.provide('goog.i18n.NumberFormatSymbols_en_NG');
goog.provide('goog.i18n.NumberFormatSymbols_en_NL');
goog.provide('goog.i18n.NumberFormatSymbols_en_NR');
goog.provide('goog.i18n.NumberFormatSymbols_en_NU');
goog.provide('goog.i18n.NumberFormatSymbols_en_NZ');
goog.provide('goog.i18n.NumberFormatSymbols_en_PG');
goog.provide('goog.i18n.NumberFormatSymbols_en_PH');
goog.provide('goog.i18n.NumberFormatSymbols_en_PK');
goog.provide('goog.i18n.NumberFormatSymbols_en_PN');
goog.provide('goog.i18n.NumberFormatSymbols_en_PR');
goog.provide('goog.i18n.NumberFormatSymbols_en_PW');
goog.provide('goog.i18n.NumberFormatSymbols_en_RW');
goog.provide('goog.i18n.NumberFormatSymbols_en_SB');
goog.provide('goog.i18n.NumberFormatSymbols_en_SC');
goog.provide('goog.i18n.NumberFormatSymbols_en_SD');
goog.provide('goog.i18n.NumberFormatSymbols_en_SE');
goog.provide('goog.i18n.NumberFormatSymbols_en_SH');
goog.provide('goog.i18n.NumberFormatSymbols_en_SI');
goog.provide('goog.i18n.NumberFormatSymbols_en_SL');
goog.provide('goog.i18n.NumberFormatSymbols_en_SS');
goog.provide('goog.i18n.NumberFormatSymbols_en_SX');
goog.provide('goog.i18n.NumberFormatSymbols_en_SZ');
goog.provide('goog.i18n.NumberFormatSymbols_en_TC');
goog.provide('goog.i18n.NumberFormatSymbols_en_TK');
goog.provide('goog.i18n.NumberFormatSymbols_en_TO');
goog.provide('goog.i18n.NumberFormatSymbols_en_TT');
goog.provide('goog.i18n.NumberFormatSymbols_en_TV');
goog.provide('goog.i18n.NumberFormatSymbols_en_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_en_UG');
goog.provide('goog.i18n.NumberFormatSymbols_en_UM');
goog.provide('goog.i18n.NumberFormatSymbols_en_US_POSIX');
goog.provide('goog.i18n.NumberFormatSymbols_en_VC');
goog.provide('goog.i18n.NumberFormatSymbols_en_VG');
goog.provide('goog.i18n.NumberFormatSymbols_en_VI');
goog.provide('goog.i18n.NumberFormatSymbols_en_VU');
goog.provide('goog.i18n.NumberFormatSymbols_en_WS');
goog.provide('goog.i18n.NumberFormatSymbols_en_XA');
goog.provide('goog.i18n.NumberFormatSymbols_en_ZM');
goog.provide('goog.i18n.NumberFormatSymbols_en_ZW');
goog.provide('goog.i18n.NumberFormatSymbols_eo');
goog.provide('goog.i18n.NumberFormatSymbols_eo_001');
goog.provide('goog.i18n.NumberFormatSymbols_es_AR');
goog.provide('goog.i18n.NumberFormatSymbols_es_BO');
goog.provide('goog.i18n.NumberFormatSymbols_es_BR');
goog.provide('goog.i18n.NumberFormatSymbols_es_BZ');
goog.provide('goog.i18n.NumberFormatSymbols_es_CL');
goog.provide('goog.i18n.NumberFormatSymbols_es_CO');
goog.provide('goog.i18n.NumberFormatSymbols_es_CR');
goog.provide('goog.i18n.NumberFormatSymbols_es_CU');
goog.provide('goog.i18n.NumberFormatSymbols_es_DO');
goog.provide('goog.i18n.NumberFormatSymbols_es_EA');
goog.provide('goog.i18n.NumberFormatSymbols_es_EC');
goog.provide('goog.i18n.NumberFormatSymbols_es_GQ');
goog.provide('goog.i18n.NumberFormatSymbols_es_GT');
goog.provide('goog.i18n.NumberFormatSymbols_es_HN');
goog.provide('goog.i18n.NumberFormatSymbols_es_IC');
goog.provide('goog.i18n.NumberFormatSymbols_es_NI');
goog.provide('goog.i18n.NumberFormatSymbols_es_PA');
goog.provide('goog.i18n.NumberFormatSymbols_es_PE');
goog.provide('goog.i18n.NumberFormatSymbols_es_PH');
goog.provide('goog.i18n.NumberFormatSymbols_es_PR');
goog.provide('goog.i18n.NumberFormatSymbols_es_PY');
goog.provide('goog.i18n.NumberFormatSymbols_es_SV');
goog.provide('goog.i18n.NumberFormatSymbols_es_UY');
goog.provide('goog.i18n.NumberFormatSymbols_es_VE');
goog.provide('goog.i18n.NumberFormatSymbols_et_EE');
goog.provide('goog.i18n.NumberFormatSymbols_eu_ES');
goog.provide('goog.i18n.NumberFormatSymbols_ewo');
goog.provide('goog.i18n.NumberFormatSymbols_ewo_CM');
goog.provide('goog.i18n.NumberFormatSymbols_fa_AF');
goog.provide('goog.i18n.NumberFormatSymbols_fa_AF_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_fa_IR');
goog.provide('goog.i18n.NumberFormatSymbols_fa_IR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_BF');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_BF_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_CM');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_CM_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GH');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GH_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GM');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GM_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GN');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GW');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_GW_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_LR');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_LR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_MR');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_MR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_NE');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_NE_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_NG');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_NG_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_SL');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_SL_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_SN');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_SN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Adlm_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_BF');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_CM');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_GH');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_GM');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_GN');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_GW');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_LR');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_MR');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_NE');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_NG');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_SL');
goog.provide('goog.i18n.NumberFormatSymbols_ff_Latn_SN');
goog.provide('goog.i18n.NumberFormatSymbols_fi_FI');
goog.provide('goog.i18n.NumberFormatSymbols_fil_PH');
goog.provide('goog.i18n.NumberFormatSymbols_fo');
goog.provide('goog.i18n.NumberFormatSymbols_fo_DK');
goog.provide('goog.i18n.NumberFormatSymbols_fo_FO');
goog.provide('goog.i18n.NumberFormatSymbols_fr_BE');
goog.provide('goog.i18n.NumberFormatSymbols_fr_BF');
goog.provide('goog.i18n.NumberFormatSymbols_fr_BI');
goog.provide('goog.i18n.NumberFormatSymbols_fr_BJ');
goog.provide('goog.i18n.NumberFormatSymbols_fr_BL');
goog.provide('goog.i18n.NumberFormatSymbols_fr_CD');
goog.provide('goog.i18n.NumberFormatSymbols_fr_CF');
goog.provide('goog.i18n.NumberFormatSymbols_fr_CG');
goog.provide('goog.i18n.NumberFormatSymbols_fr_CH');
goog.provide('goog.i18n.NumberFormatSymbols_fr_CI');
goog.provide('goog.i18n.NumberFormatSymbols_fr_CM');
goog.provide('goog.i18n.NumberFormatSymbols_fr_DJ');
goog.provide('goog.i18n.NumberFormatSymbols_fr_DZ');
goog.provide('goog.i18n.NumberFormatSymbols_fr_FR');
goog.provide('goog.i18n.NumberFormatSymbols_fr_GA');
goog.provide('goog.i18n.NumberFormatSymbols_fr_GF');
goog.provide('goog.i18n.NumberFormatSymbols_fr_GN');
goog.provide('goog.i18n.NumberFormatSymbols_fr_GP');
goog.provide('goog.i18n.NumberFormatSymbols_fr_GQ');
goog.provide('goog.i18n.NumberFormatSymbols_fr_HT');
goog.provide('goog.i18n.NumberFormatSymbols_fr_KM');
goog.provide('goog.i18n.NumberFormatSymbols_fr_LU');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MA');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MC');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MF');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MG');
goog.provide('goog.i18n.NumberFormatSymbols_fr_ML');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MQ');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MR');
goog.provide('goog.i18n.NumberFormatSymbols_fr_MU');
goog.provide('goog.i18n.NumberFormatSymbols_fr_NC');
goog.provide('goog.i18n.NumberFormatSymbols_fr_NE');
goog.provide('goog.i18n.NumberFormatSymbols_fr_PF');
goog.provide('goog.i18n.NumberFormatSymbols_fr_PM');
goog.provide('goog.i18n.NumberFormatSymbols_fr_RE');
goog.provide('goog.i18n.NumberFormatSymbols_fr_RW');
goog.provide('goog.i18n.NumberFormatSymbols_fr_SC');
goog.provide('goog.i18n.NumberFormatSymbols_fr_SN');
goog.provide('goog.i18n.NumberFormatSymbols_fr_SY');
goog.provide('goog.i18n.NumberFormatSymbols_fr_TD');
goog.provide('goog.i18n.NumberFormatSymbols_fr_TG');
goog.provide('goog.i18n.NumberFormatSymbols_fr_TN');
goog.provide('goog.i18n.NumberFormatSymbols_fr_VU');
goog.provide('goog.i18n.NumberFormatSymbols_fr_WF');
goog.provide('goog.i18n.NumberFormatSymbols_fr_YT');
goog.provide('goog.i18n.NumberFormatSymbols_fur');
goog.provide('goog.i18n.NumberFormatSymbols_fur_IT');
goog.provide('goog.i18n.NumberFormatSymbols_fy');
goog.provide('goog.i18n.NumberFormatSymbols_fy_NL');
goog.provide('goog.i18n.NumberFormatSymbols_ga_GB');
goog.provide('goog.i18n.NumberFormatSymbols_ga_IE');
goog.provide('goog.i18n.NumberFormatSymbols_gd');
goog.provide('goog.i18n.NumberFormatSymbols_gd_GB');
goog.provide('goog.i18n.NumberFormatSymbols_gl_ES');
goog.provide('goog.i18n.NumberFormatSymbols_gsw_CH');
goog.provide('goog.i18n.NumberFormatSymbols_gsw_FR');
goog.provide('goog.i18n.NumberFormatSymbols_gsw_LI');
goog.provide('goog.i18n.NumberFormatSymbols_gu_IN');
goog.provide('goog.i18n.NumberFormatSymbols_guz');
goog.provide('goog.i18n.NumberFormatSymbols_guz_KE');
goog.provide('goog.i18n.NumberFormatSymbols_gv');
goog.provide('goog.i18n.NumberFormatSymbols_gv_IM');
goog.provide('goog.i18n.NumberFormatSymbols_ha');
goog.provide('goog.i18n.NumberFormatSymbols_ha_GH');
goog.provide('goog.i18n.NumberFormatSymbols_ha_NE');
goog.provide('goog.i18n.NumberFormatSymbols_ha_NG');
goog.provide('goog.i18n.NumberFormatSymbols_haw_US');
goog.provide('goog.i18n.NumberFormatSymbols_he_IL');
goog.provide('goog.i18n.NumberFormatSymbols_hi_IN');
goog.provide('goog.i18n.NumberFormatSymbols_hi_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_hi_Latn_IN');
goog.provide('goog.i18n.NumberFormatSymbols_hr_BA');
goog.provide('goog.i18n.NumberFormatSymbols_hr_HR');
goog.provide('goog.i18n.NumberFormatSymbols_hsb');
goog.provide('goog.i18n.NumberFormatSymbols_hsb_DE');
goog.provide('goog.i18n.NumberFormatSymbols_hu_HU');
goog.provide('goog.i18n.NumberFormatSymbols_hy_AM');
goog.provide('goog.i18n.NumberFormatSymbols_ia');
goog.provide('goog.i18n.NumberFormatSymbols_ia_001');
goog.provide('goog.i18n.NumberFormatSymbols_id_ID');
goog.provide('goog.i18n.NumberFormatSymbols_ig');
goog.provide('goog.i18n.NumberFormatSymbols_ig_NG');
goog.provide('goog.i18n.NumberFormatSymbols_ii');
goog.provide('goog.i18n.NumberFormatSymbols_ii_CN');
goog.provide('goog.i18n.NumberFormatSymbols_is_IS');
goog.provide('goog.i18n.NumberFormatSymbols_it_CH');
goog.provide('goog.i18n.NumberFormatSymbols_it_IT');
goog.provide('goog.i18n.NumberFormatSymbols_it_SM');
goog.provide('goog.i18n.NumberFormatSymbols_it_VA');
goog.provide('goog.i18n.NumberFormatSymbols_ja_JP');
goog.provide('goog.i18n.NumberFormatSymbols_jgo');
goog.provide('goog.i18n.NumberFormatSymbols_jgo_CM');
goog.provide('goog.i18n.NumberFormatSymbols_jmc');
goog.provide('goog.i18n.NumberFormatSymbols_jmc_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_jv');
goog.provide('goog.i18n.NumberFormatSymbols_jv_ID');
goog.provide('goog.i18n.NumberFormatSymbols_ka_GE');
goog.provide('goog.i18n.NumberFormatSymbols_kab');
goog.provide('goog.i18n.NumberFormatSymbols_kab_DZ');
goog.provide('goog.i18n.NumberFormatSymbols_kam');
goog.provide('goog.i18n.NumberFormatSymbols_kam_KE');
goog.provide('goog.i18n.NumberFormatSymbols_kde');
goog.provide('goog.i18n.NumberFormatSymbols_kde_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_kea');
goog.provide('goog.i18n.NumberFormatSymbols_kea_CV');
goog.provide('goog.i18n.NumberFormatSymbols_kgp');
goog.provide('goog.i18n.NumberFormatSymbols_kgp_BR');
goog.provide('goog.i18n.NumberFormatSymbols_khq');
goog.provide('goog.i18n.NumberFormatSymbols_khq_ML');
goog.provide('goog.i18n.NumberFormatSymbols_ki');
goog.provide('goog.i18n.NumberFormatSymbols_ki_KE');
goog.provide('goog.i18n.NumberFormatSymbols_kk_KZ');
goog.provide('goog.i18n.NumberFormatSymbols_kkj');
goog.provide('goog.i18n.NumberFormatSymbols_kkj_CM');
goog.provide('goog.i18n.NumberFormatSymbols_kl');
goog.provide('goog.i18n.NumberFormatSymbols_kl_GL');
goog.provide('goog.i18n.NumberFormatSymbols_kln');
goog.provide('goog.i18n.NumberFormatSymbols_kln_KE');
goog.provide('goog.i18n.NumberFormatSymbols_km_KH');
goog.provide('goog.i18n.NumberFormatSymbols_kn_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ko_KP');
goog.provide('goog.i18n.NumberFormatSymbols_ko_KR');
goog.provide('goog.i18n.NumberFormatSymbols_kok');
goog.provide('goog.i18n.NumberFormatSymbols_kok_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ks');
goog.provide('goog.i18n.NumberFormatSymbols_ks_Arab');
goog.provide('goog.i18n.NumberFormatSymbols_ks_Arab_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ks_Arab_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ks_Arab_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ks_Deva');
goog.provide('goog.i18n.NumberFormatSymbols_ks_Deva_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ks_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ksb');
goog.provide('goog.i18n.NumberFormatSymbols_ksb_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_ksf');
goog.provide('goog.i18n.NumberFormatSymbols_ksf_CM');
goog.provide('goog.i18n.NumberFormatSymbols_ksh');
goog.provide('goog.i18n.NumberFormatSymbols_ksh_DE');
goog.provide('goog.i18n.NumberFormatSymbols_ku');
goog.provide('goog.i18n.NumberFormatSymbols_ku_TR');
goog.provide('goog.i18n.NumberFormatSymbols_kw');
goog.provide('goog.i18n.NumberFormatSymbols_kw_GB');
goog.provide('goog.i18n.NumberFormatSymbols_ky_KG');
goog.provide('goog.i18n.NumberFormatSymbols_lag');
goog.provide('goog.i18n.NumberFormatSymbols_lag_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_lb');
goog.provide('goog.i18n.NumberFormatSymbols_lb_LU');
goog.provide('goog.i18n.NumberFormatSymbols_lg');
goog.provide('goog.i18n.NumberFormatSymbols_lg_UG');
goog.provide('goog.i18n.NumberFormatSymbols_lkt');
goog.provide('goog.i18n.NumberFormatSymbols_lkt_US');
goog.provide('goog.i18n.NumberFormatSymbols_ln_AO');
goog.provide('goog.i18n.NumberFormatSymbols_ln_CD');
goog.provide('goog.i18n.NumberFormatSymbols_ln_CF');
goog.provide('goog.i18n.NumberFormatSymbols_ln_CG');
goog.provide('goog.i18n.NumberFormatSymbols_lo_LA');
goog.provide('goog.i18n.NumberFormatSymbols_lrc');
goog.provide('goog.i18n.NumberFormatSymbols_lrc_IQ');
goog.provide('goog.i18n.NumberFormatSymbols_lrc_IQ_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_lrc_IR');
goog.provide('goog.i18n.NumberFormatSymbols_lrc_IR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_lrc_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_lt_LT');
goog.provide('goog.i18n.NumberFormatSymbols_lu');
goog.provide('goog.i18n.NumberFormatSymbols_lu_CD');
goog.provide('goog.i18n.NumberFormatSymbols_luo');
goog.provide('goog.i18n.NumberFormatSymbols_luo_KE');
goog.provide('goog.i18n.NumberFormatSymbols_luy');
goog.provide('goog.i18n.NumberFormatSymbols_luy_KE');
goog.provide('goog.i18n.NumberFormatSymbols_lv_LV');
goog.provide('goog.i18n.NumberFormatSymbols_mai');
goog.provide('goog.i18n.NumberFormatSymbols_mai_IN');
goog.provide('goog.i18n.NumberFormatSymbols_mas');
goog.provide('goog.i18n.NumberFormatSymbols_mas_KE');
goog.provide('goog.i18n.NumberFormatSymbols_mas_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_mer');
goog.provide('goog.i18n.NumberFormatSymbols_mer_KE');
goog.provide('goog.i18n.NumberFormatSymbols_mfe');
goog.provide('goog.i18n.NumberFormatSymbols_mfe_MU');
goog.provide('goog.i18n.NumberFormatSymbols_mg');
goog.provide('goog.i18n.NumberFormatSymbols_mg_MG');
goog.provide('goog.i18n.NumberFormatSymbols_mgh');
goog.provide('goog.i18n.NumberFormatSymbols_mgh_MZ');
goog.provide('goog.i18n.NumberFormatSymbols_mgo');
goog.provide('goog.i18n.NumberFormatSymbols_mgo_CM');
goog.provide('goog.i18n.NumberFormatSymbols_mi');
goog.provide('goog.i18n.NumberFormatSymbols_mi_NZ');
goog.provide('goog.i18n.NumberFormatSymbols_mk_MK');
goog.provide('goog.i18n.NumberFormatSymbols_ml_IN');
goog.provide('goog.i18n.NumberFormatSymbols_mn_MN');
goog.provide('goog.i18n.NumberFormatSymbols_mni');
goog.provide('goog.i18n.NumberFormatSymbols_mni_Beng');
goog.provide('goog.i18n.NumberFormatSymbols_mni_Beng_IN');
goog.provide('goog.i18n.NumberFormatSymbols_mni_Beng_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_mni_Beng_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_mni_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_mr_IN');
goog.provide('goog.i18n.NumberFormatSymbols_mr_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ms_BN');
goog.provide('goog.i18n.NumberFormatSymbols_ms_ID');
goog.provide('goog.i18n.NumberFormatSymbols_ms_MY');
goog.provide('goog.i18n.NumberFormatSymbols_ms_SG');
goog.provide('goog.i18n.NumberFormatSymbols_mt_MT');
goog.provide('goog.i18n.NumberFormatSymbols_mua');
goog.provide('goog.i18n.NumberFormatSymbols_mua_CM');
goog.provide('goog.i18n.NumberFormatSymbols_my_MM');
goog.provide('goog.i18n.NumberFormatSymbols_my_MM_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_mzn');
goog.provide('goog.i18n.NumberFormatSymbols_mzn_IR');
goog.provide('goog.i18n.NumberFormatSymbols_mzn_IR_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_mzn_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_naq');
goog.provide('goog.i18n.NumberFormatSymbols_naq_NA');
goog.provide('goog.i18n.NumberFormatSymbols_nb_NO');
goog.provide('goog.i18n.NumberFormatSymbols_nb_SJ');
goog.provide('goog.i18n.NumberFormatSymbols_nd');
goog.provide('goog.i18n.NumberFormatSymbols_nd_ZW');
goog.provide('goog.i18n.NumberFormatSymbols_ne_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ne_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ne_NP');
goog.provide('goog.i18n.NumberFormatSymbols_ne_NP_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_nl_AW');
goog.provide('goog.i18n.NumberFormatSymbols_nl_BE');
goog.provide('goog.i18n.NumberFormatSymbols_nl_BQ');
goog.provide('goog.i18n.NumberFormatSymbols_nl_CW');
goog.provide('goog.i18n.NumberFormatSymbols_nl_NL');
goog.provide('goog.i18n.NumberFormatSymbols_nl_SR');
goog.provide('goog.i18n.NumberFormatSymbols_nl_SX');
goog.provide('goog.i18n.NumberFormatSymbols_nmg');
goog.provide('goog.i18n.NumberFormatSymbols_nmg_CM');
goog.provide('goog.i18n.NumberFormatSymbols_nn');
goog.provide('goog.i18n.NumberFormatSymbols_nn_NO');
goog.provide('goog.i18n.NumberFormatSymbols_nnh');
goog.provide('goog.i18n.NumberFormatSymbols_nnh_CM');
goog.provide('goog.i18n.NumberFormatSymbols_nus');
goog.provide('goog.i18n.NumberFormatSymbols_nus_SS');
goog.provide('goog.i18n.NumberFormatSymbols_nyn');
goog.provide('goog.i18n.NumberFormatSymbols_nyn_UG');
goog.provide('goog.i18n.NumberFormatSymbols_om');
goog.provide('goog.i18n.NumberFormatSymbols_om_ET');
goog.provide('goog.i18n.NumberFormatSymbols_om_KE');
goog.provide('goog.i18n.NumberFormatSymbols_or_IN');
goog.provide('goog.i18n.NumberFormatSymbols_os');
goog.provide('goog.i18n.NumberFormatSymbols_os_GE');
goog.provide('goog.i18n.NumberFormatSymbols_os_RU');
goog.provide('goog.i18n.NumberFormatSymbols_pa_Arab');
goog.provide('goog.i18n.NumberFormatSymbols_pa_Arab_PK');
goog.provide('goog.i18n.NumberFormatSymbols_pa_Arab_PK_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_pa_Arab_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_pa_Guru');
goog.provide('goog.i18n.NumberFormatSymbols_pa_Guru_IN');
goog.provide('goog.i18n.NumberFormatSymbols_pcm');
goog.provide('goog.i18n.NumberFormatSymbols_pcm_NG');
goog.provide('goog.i18n.NumberFormatSymbols_pl_PL');
goog.provide('goog.i18n.NumberFormatSymbols_ps');
goog.provide('goog.i18n.NumberFormatSymbols_ps_AF');
goog.provide('goog.i18n.NumberFormatSymbols_ps_AF_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ps_PK');
goog.provide('goog.i18n.NumberFormatSymbols_ps_PK_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ps_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_pt_AO');
goog.provide('goog.i18n.NumberFormatSymbols_pt_CH');
goog.provide('goog.i18n.NumberFormatSymbols_pt_CV');
goog.provide('goog.i18n.NumberFormatSymbols_pt_GQ');
goog.provide('goog.i18n.NumberFormatSymbols_pt_GW');
goog.provide('goog.i18n.NumberFormatSymbols_pt_LU');
goog.provide('goog.i18n.NumberFormatSymbols_pt_MO');
goog.provide('goog.i18n.NumberFormatSymbols_pt_MZ');
goog.provide('goog.i18n.NumberFormatSymbols_pt_ST');
goog.provide('goog.i18n.NumberFormatSymbols_pt_TL');
goog.provide('goog.i18n.NumberFormatSymbols_qu');
goog.provide('goog.i18n.NumberFormatSymbols_qu_BO');
goog.provide('goog.i18n.NumberFormatSymbols_qu_EC');
goog.provide('goog.i18n.NumberFormatSymbols_qu_PE');
goog.provide('goog.i18n.NumberFormatSymbols_raj');
goog.provide('goog.i18n.NumberFormatSymbols_raj_IN');
goog.provide('goog.i18n.NumberFormatSymbols_raj_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_raj_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_rm');
goog.provide('goog.i18n.NumberFormatSymbols_rm_CH');
goog.provide('goog.i18n.NumberFormatSymbols_rn');
goog.provide('goog.i18n.NumberFormatSymbols_rn_BI');
goog.provide('goog.i18n.NumberFormatSymbols_ro_MD');
goog.provide('goog.i18n.NumberFormatSymbols_ro_RO');
goog.provide('goog.i18n.NumberFormatSymbols_rof');
goog.provide('goog.i18n.NumberFormatSymbols_rof_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_ru_BY');
goog.provide('goog.i18n.NumberFormatSymbols_ru_KG');
goog.provide('goog.i18n.NumberFormatSymbols_ru_KZ');
goog.provide('goog.i18n.NumberFormatSymbols_ru_MD');
goog.provide('goog.i18n.NumberFormatSymbols_ru_RU');
goog.provide('goog.i18n.NumberFormatSymbols_ru_UA');
goog.provide('goog.i18n.NumberFormatSymbols_rw');
goog.provide('goog.i18n.NumberFormatSymbols_rw_RW');
goog.provide('goog.i18n.NumberFormatSymbols_rwk');
goog.provide('goog.i18n.NumberFormatSymbols_rwk_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_sa');
goog.provide('goog.i18n.NumberFormatSymbols_sa_IN');
goog.provide('goog.i18n.NumberFormatSymbols_sa_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sa_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sah');
goog.provide('goog.i18n.NumberFormatSymbols_sah_RU');
goog.provide('goog.i18n.NumberFormatSymbols_saq');
goog.provide('goog.i18n.NumberFormatSymbols_saq_KE');
goog.provide('goog.i18n.NumberFormatSymbols_sat');
goog.provide('goog.i18n.NumberFormatSymbols_sat_Olck');
goog.provide('goog.i18n.NumberFormatSymbols_sat_Olck_IN');
goog.provide('goog.i18n.NumberFormatSymbols_sat_Olck_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sat_Olck_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sat_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sbp');
goog.provide('goog.i18n.NumberFormatSymbols_sbp_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_sc');
goog.provide('goog.i18n.NumberFormatSymbols_sc_IT');
goog.provide('goog.i18n.NumberFormatSymbols_sd');
goog.provide('goog.i18n.NumberFormatSymbols_sd_Arab');
goog.provide('goog.i18n.NumberFormatSymbols_sd_Arab_PK');
goog.provide('goog.i18n.NumberFormatSymbols_sd_Arab_PK_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sd_Arab_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_sd_Deva');
goog.provide('goog.i18n.NumberFormatSymbols_sd_Deva_IN');
goog.provide('goog.i18n.NumberFormatSymbols_sd_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_se');
goog.provide('goog.i18n.NumberFormatSymbols_se_FI');
goog.provide('goog.i18n.NumberFormatSymbols_se_NO');
goog.provide('goog.i18n.NumberFormatSymbols_se_SE');
goog.provide('goog.i18n.NumberFormatSymbols_seh');
goog.provide('goog.i18n.NumberFormatSymbols_seh_MZ');
goog.provide('goog.i18n.NumberFormatSymbols_ses');
goog.provide('goog.i18n.NumberFormatSymbols_ses_ML');
goog.provide('goog.i18n.NumberFormatSymbols_sg');
goog.provide('goog.i18n.NumberFormatSymbols_sg_CF');
goog.provide('goog.i18n.NumberFormatSymbols_shi');
goog.provide('goog.i18n.NumberFormatSymbols_shi_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_shi_Latn_MA');
goog.provide('goog.i18n.NumberFormatSymbols_shi_Tfng');
goog.provide('goog.i18n.NumberFormatSymbols_shi_Tfng_MA');
goog.provide('goog.i18n.NumberFormatSymbols_si_LK');
goog.provide('goog.i18n.NumberFormatSymbols_sk_SK');
goog.provide('goog.i18n.NumberFormatSymbols_sl_SI');
goog.provide('goog.i18n.NumberFormatSymbols_smn');
goog.provide('goog.i18n.NumberFormatSymbols_smn_FI');
goog.provide('goog.i18n.NumberFormatSymbols_sn');
goog.provide('goog.i18n.NumberFormatSymbols_sn_ZW');
goog.provide('goog.i18n.NumberFormatSymbols_so');
goog.provide('goog.i18n.NumberFormatSymbols_so_DJ');
goog.provide('goog.i18n.NumberFormatSymbols_so_ET');
goog.provide('goog.i18n.NumberFormatSymbols_so_KE');
goog.provide('goog.i18n.NumberFormatSymbols_so_SO');
goog.provide('goog.i18n.NumberFormatSymbols_sq_AL');
goog.provide('goog.i18n.NumberFormatSymbols_sq_MK');
goog.provide('goog.i18n.NumberFormatSymbols_sq_XK');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Cyrl');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Cyrl_BA');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Cyrl_ME');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Cyrl_RS');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Cyrl_XK');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Latn_BA');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Latn_ME');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Latn_RS');
goog.provide('goog.i18n.NumberFormatSymbols_sr_Latn_XK');
goog.provide('goog.i18n.NumberFormatSymbols_su');
goog.provide('goog.i18n.NumberFormatSymbols_su_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_su_Latn_ID');
goog.provide('goog.i18n.NumberFormatSymbols_sv_AX');
goog.provide('goog.i18n.NumberFormatSymbols_sv_FI');
goog.provide('goog.i18n.NumberFormatSymbols_sv_SE');
goog.provide('goog.i18n.NumberFormatSymbols_sw_CD');
goog.provide('goog.i18n.NumberFormatSymbols_sw_KE');
goog.provide('goog.i18n.NumberFormatSymbols_sw_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_sw_UG');
goog.provide('goog.i18n.NumberFormatSymbols_ta_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ta_LK');
goog.provide('goog.i18n.NumberFormatSymbols_ta_MY');
goog.provide('goog.i18n.NumberFormatSymbols_ta_SG');
goog.provide('goog.i18n.NumberFormatSymbols_te_IN');
goog.provide('goog.i18n.NumberFormatSymbols_teo');
goog.provide('goog.i18n.NumberFormatSymbols_teo_KE');
goog.provide('goog.i18n.NumberFormatSymbols_teo_UG');
goog.provide('goog.i18n.NumberFormatSymbols_tg');
goog.provide('goog.i18n.NumberFormatSymbols_tg_TJ');
goog.provide('goog.i18n.NumberFormatSymbols_th_TH');
goog.provide('goog.i18n.NumberFormatSymbols_ti');
goog.provide('goog.i18n.NumberFormatSymbols_ti_ER');
goog.provide('goog.i18n.NumberFormatSymbols_ti_ET');
goog.provide('goog.i18n.NumberFormatSymbols_tk');
goog.provide('goog.i18n.NumberFormatSymbols_tk_TM');
goog.provide('goog.i18n.NumberFormatSymbols_to');
goog.provide('goog.i18n.NumberFormatSymbols_to_TO');
goog.provide('goog.i18n.NumberFormatSymbols_tr_CY');
goog.provide('goog.i18n.NumberFormatSymbols_tr_TR');
goog.provide('goog.i18n.NumberFormatSymbols_tt');
goog.provide('goog.i18n.NumberFormatSymbols_tt_RU');
goog.provide('goog.i18n.NumberFormatSymbols_twq');
goog.provide('goog.i18n.NumberFormatSymbols_twq_NE');
goog.provide('goog.i18n.NumberFormatSymbols_tzm');
goog.provide('goog.i18n.NumberFormatSymbols_tzm_MA');
goog.provide('goog.i18n.NumberFormatSymbols_ug');
goog.provide('goog.i18n.NumberFormatSymbols_ug_CN');
goog.provide('goog.i18n.NumberFormatSymbols_uk_UA');
goog.provide('goog.i18n.NumberFormatSymbols_ur_IN');
goog.provide('goog.i18n.NumberFormatSymbols_ur_IN_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_ur_PK');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Arab');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Arab_AF');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Arab_AF_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Arab_u_nu_latn');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Cyrl');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Cyrl_UZ');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_uz_Latn_UZ');
goog.provide('goog.i18n.NumberFormatSymbols_vai');
goog.provide('goog.i18n.NumberFormatSymbols_vai_Latn');
goog.provide('goog.i18n.NumberFormatSymbols_vai_Latn_LR');
goog.provide('goog.i18n.NumberFormatSymbols_vai_Vaii');
goog.provide('goog.i18n.NumberFormatSymbols_vai_Vaii_LR');
goog.provide('goog.i18n.NumberFormatSymbols_vi_VN');
goog.provide('goog.i18n.NumberFormatSymbols_vun');
goog.provide('goog.i18n.NumberFormatSymbols_vun_TZ');
goog.provide('goog.i18n.NumberFormatSymbols_wae');
goog.provide('goog.i18n.NumberFormatSymbols_wae_CH');
goog.provide('goog.i18n.NumberFormatSymbols_wo');
goog.provide('goog.i18n.NumberFormatSymbols_wo_SN');
goog.provide('goog.i18n.NumberFormatSymbols_xh');
goog.provide('goog.i18n.NumberFormatSymbols_xh_ZA');
goog.provide('goog.i18n.NumberFormatSymbols_xog');
goog.provide('goog.i18n.NumberFormatSymbols_xog_UG');
goog.provide('goog.i18n.NumberFormatSymbols_yav');
goog.provide('goog.i18n.NumberFormatSymbols_yav_CM');
goog.provide('goog.i18n.NumberFormatSymbols_yi');
goog.provide('goog.i18n.NumberFormatSymbols_yi_001');
goog.provide('goog.i18n.NumberFormatSymbols_yo');
goog.provide('goog.i18n.NumberFormatSymbols_yo_BJ');
goog.provide('goog.i18n.NumberFormatSymbols_yo_NG');
goog.provide('goog.i18n.NumberFormatSymbols_yrl');
goog.provide('goog.i18n.NumberFormatSymbols_yrl_BR');
goog.provide('goog.i18n.NumberFormatSymbols_yrl_CO');
goog.provide('goog.i18n.NumberFormatSymbols_yrl_VE');
goog.provide('goog.i18n.NumberFormatSymbols_yue');
goog.provide('goog.i18n.NumberFormatSymbols_yue_Hans');
goog.provide('goog.i18n.NumberFormatSymbols_yue_Hans_CN');
goog.provide('goog.i18n.NumberFormatSymbols_yue_Hant');
goog.provide('goog.i18n.NumberFormatSymbols_yue_Hant_HK');
goog.provide('goog.i18n.NumberFormatSymbols_zgh');
goog.provide('goog.i18n.NumberFormatSymbols_zgh_MA');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hans');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hans_CN');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hans_HK');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hans_MO');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hans_SG');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hant');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hant_HK');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hant_MO');
goog.provide('goog.i18n.NumberFormatSymbols_zh_Hant_TW');
goog.provide('goog.i18n.NumberFormatSymbols_zu_ZA');
goog.require('goog.i18n.NumberFormatSymbols');
goog.require('goog.i18n.NumberFormatSymbols_u_nu_latn');

goog.requireType('goog.i18n.NumberFormatSymbolsType');


/**
 * Number formatting symbols for locale af_NA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_af_NA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NAD'
};


/**
 * Number formatting symbols for locale af_ZA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_af_ZA = goog.i18n.NumberFormatSymbols_af;


/**
 * Number formatting symbols for locale agq.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_agq = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale agq_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_agq_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ak.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ak = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale ak_GH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ak_GH = goog.i18n.NumberFormatSymbols_ak;


/**
 * Number formatting symbols for locale am_ET.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_am_ET = goog.i18n.NumberFormatSymbols_am;


/**
 * Number formatting symbols for locale ar_001.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_001 = goog.i18n.NumberFormatSymbols_ar;


/**
 * Number formatting symbols for locale ar_AE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_AE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'AED'
};


/**
 * Number formatting symbols for locale ar_BH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_BH = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'BHD'
};


/**
 * Number formatting symbols for locale ar_BH_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_BH_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤;‏-#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'BHD'
};


/**
 * Number formatting symbols for locale ar_DJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_DJ = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'DJF'
};


/**
 * Number formatting symbols for locale ar_DJ_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_DJ_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'DJF'
};


/**
 * Number formatting symbols for locale ar_EH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_EH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MAD'
};


/**
 * Number formatting symbols for locale ar_ER.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_ER = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'ERN'
};


/**
 * Number formatting symbols for locale ar_ER_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_ER_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'ERN'
};


/**
 * Number formatting symbols for locale ar_IL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_IL = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'ILS'
};


/**
 * Number formatting symbols for locale ar_IL_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_IL_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'ILS'
};


/**
 * Number formatting symbols for locale ar_IQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_IQ = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ar_IQ_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_IQ_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ar_JO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_JO = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'JOD'
};


/**
 * Number formatting symbols for locale ar_JO_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_JO_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤;‏-#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'JOD'
};


/**
 * Number formatting symbols for locale ar_KM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_KM = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'KMF'
};


/**
 * Number formatting symbols for locale ar_KM_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_KM_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'KMF'
};


/**
 * Number formatting symbols for locale ar_KW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_KW = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'KWD'
};


/**
 * Number formatting symbols for locale ar_KW_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_KW_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤;‏-#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'KWD'
};


/**
 * Number formatting symbols for locale ar_LB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_LB = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'LBP'
};


/**
 * Number formatting symbols for locale ar_LB_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_LB_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'LBP'
};


/**
 * Number formatting symbols for locale ar_LY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_LY = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤;‏-#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'LYD'
};


/**
 * Number formatting symbols for locale ar_MA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_MA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MAD'
};


/**
 * Number formatting symbols for locale ar_MR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_MR = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MRU'
};


/**
 * Number formatting symbols for locale ar_MR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_MR_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MRU'
};


/**
 * Number formatting symbols for locale ar_OM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_OM = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'OMR'
};


/**
 * Number formatting symbols for locale ar_OM_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_OM_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤;‏-#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'OMR'
};


/**
 * Number formatting symbols for locale ar_PS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_PS = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'ILS'
};


/**
 * Number formatting symbols for locale ar_PS_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_PS_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'ILS'
};


/**
 * Number formatting symbols for locale ar_QA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_QA = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'QAR'
};


/**
 * Number formatting symbols for locale ar_QA_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_QA_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'QAR'
};


/**
 * Number formatting symbols for locale ar_SA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SA = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SAR'
};


/**
 * Number formatting symbols for locale ar_SA_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SA_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '٪',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SAR'
};


/**
 * Number formatting symbols for locale ar_SD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SD = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SDG'
};


/**
 * Number formatting symbols for locale ar_SD_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SD_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SDG'
};


/**
 * Number formatting symbols for locale ar_SO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SO = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'SOS'
};


/**
 * Number formatting symbols for locale ar_SO_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SO_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '٪',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'SOS'
};


/**
 * Number formatting symbols for locale ar_SS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SS = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SSP'
};


/**
 * Number formatting symbols for locale ar_SS_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SS_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.00 ¤;‏-#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SSP'
};


/**
 * Number formatting symbols for locale ar_SY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SY = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'SYP'
};


/**
 * Number formatting symbols for locale ar_SY_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_SY_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'SYP'
};


/**
 * Number formatting symbols for locale ar_TD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_TD = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ar_TD_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_TD_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ar_TN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_TN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0.000 ¤;‏-#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'TND'
};


/**
 * Number formatting symbols for locale ar_XB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_XB = goog.i18n.NumberFormatSymbols_ar;


/**
 * Number formatting symbols for locale ar_YE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_YE = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ليس رقم',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤',
  DEF_CURRENCY_CODE: 'YER'
};


/**
 * Number formatting symbols for locale ar_YE_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ar_YE_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '‎%‎',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ليس رقمًا',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‏#,##0 ¤;‏-#,##0 ¤',
  DEF_CURRENCY_CODE: 'YER'
};


/**
 * Number formatting symbols for locale as.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_as = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '০',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤ #,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale as_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_as_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤ #,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale as_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_as_IN = goog.i18n.NumberFormatSymbols_as;


/**
 * Number formatting symbols for locale as_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_as_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_as_u_nu_latn;


/**
 * Number formatting symbols for locale asa.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_asa = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale asa_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_asa_TZ = goog.i18n.NumberFormatSymbols_asa;


/**
 * Number formatting symbols for locale ast.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ast = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ND',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale ast_ES.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ast_ES = goog.i18n.NumberFormatSymbols_ast;


/**
 * Number formatting symbols for locale az_Cyrl.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_az_Cyrl = goog.i18n.NumberFormatSymbols_az;


/**
 * Number formatting symbols for locale az_Cyrl_AZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_az_Cyrl_AZ = goog.i18n.NumberFormatSymbols_az;


/**
 * Number formatting symbols for locale az_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_az_Latn = goog.i18n.NumberFormatSymbols_az;


/**
 * Number formatting symbols for locale az_Latn_AZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_az_Latn_AZ = goog.i18n.NumberFormatSymbols_az;


/**
 * Number formatting symbols for locale bas.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bas = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale bas_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bas_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale be_BY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_be_BY = goog.i18n.NumberFormatSymbols_be;


/**
 * Number formatting symbols for locale bem.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bem = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ZMW'
};


/**
 * Number formatting symbols for locale bem_ZM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bem_ZM = goog.i18n.NumberFormatSymbols_bem;


/**
 * Number formatting symbols for locale bez.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bez = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale bez_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bez_TZ = goog.i18n.NumberFormatSymbols_bez;


/**
 * Number formatting symbols for locale bg_BG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bg_BG = goog.i18n.NumberFormatSymbols_bg;


/**
 * Number formatting symbols for locale bgc.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bgc = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '०',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale bgc_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bgc_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale bgc_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bgc_IN = goog.i18n.NumberFormatSymbols_bgc;


/**
 * Number formatting symbols for locale bgc_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bgc_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_bgc_u_nu_latn;


/**
 * Number formatting symbols for locale bho.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bho = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '०',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale bho_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bho_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale bho_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bho_IN = goog.i18n.NumberFormatSymbols_bho;


/**
 * Number formatting symbols for locale bho_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bho_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_bho_u_nu_latn;


/**
 * Number formatting symbols for locale bm.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bm = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale bm_ML.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bm_ML = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale bn_BD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bn_BD = goog.i18n.NumberFormatSymbols_bn;


/**
 * Number formatting symbols for locale bn_BD_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bn_BD_u_nu_latn = goog.i18n.NumberFormatSymbols_bn_u_nu_latn;


/**
 * Number formatting symbols for locale bn_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bn_IN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '০',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale bn_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bn_IN_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale bo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bo = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'CNY'
};


/**
 * Number formatting symbols for locale bo_CN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bo_CN = goog.i18n.NumberFormatSymbols_bo;


/**
 * Number formatting symbols for locale bo_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bo_IN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale br_FR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_br_FR = goog.i18n.NumberFormatSymbols_br;


/**
 * Number formatting symbols for locale brx.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_brx = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤ #,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale brx_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_brx_IN = goog.i18n.NumberFormatSymbols_brx;


/**
 * Number formatting symbols for locale bs_Cyrl.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bs_Cyrl = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'BAM'
};


/**
 * Number formatting symbols for locale bs_Cyrl_BA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bs_Cyrl_BA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'BAM'
};


/**
 * Number formatting symbols for locale bs_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bs_Latn = goog.i18n.NumberFormatSymbols_bs;


/**
 * Number formatting symbols for locale bs_Latn_BA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_bs_Latn_BA = goog.i18n.NumberFormatSymbols_bs;


/**
 * Number formatting symbols for locale ca_AD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ca_AD = goog.i18n.NumberFormatSymbols_ca;


/**
 * Number formatting symbols for locale ca_ES.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ca_ES = goog.i18n.NumberFormatSymbols_ca;


/**
 * Number formatting symbols for locale ca_FR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ca_FR = goog.i18n.NumberFormatSymbols_ca;


/**
 * Number formatting symbols for locale ca_IT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ca_IT = goog.i18n.NumberFormatSymbols_ca;


/**
 * Number formatting symbols for locale ccp.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ccp = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##,##0.00¤',
  DEF_CURRENCY_CODE: 'BDT'
};


/**
 * Number formatting symbols for locale ccp_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ccp_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '#,##,##0.00¤',
  DEF_CURRENCY_CODE: 'BDT'
};


/**
 * Number formatting symbols for locale ccp_BD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ccp_BD = goog.i18n.NumberFormatSymbols_ccp;


/**
 * Number formatting symbols for locale ccp_BD_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ccp_BD_u_nu_latn = goog.i18n.NumberFormatSymbols_ccp_u_nu_latn;


/**
 * Number formatting symbols for locale ccp_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ccp_IN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##,##0.00¤',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ccp_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ccp_IN_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '#,##,##0.00¤',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ce.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ce = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'Терхьаш дац',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'RUB'
};


/**
 * Number formatting symbols for locale ce_RU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ce_RU = goog.i18n.NumberFormatSymbols_ce;


/**
 * Number formatting symbols for locale ceb.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ceb = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'PHP'
};


/**
 * Number formatting symbols for locale ceb_PH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ceb_PH = goog.i18n.NumberFormatSymbols_ceb;


/**
 * Number formatting symbols for locale cgg.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_cgg = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale cgg_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_cgg_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale chr_US.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_chr_US = goog.i18n.NumberFormatSymbols_chr;


/**
 * Number formatting symbols for locale ckb.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '‏+',
  MINUS_SIGN: '‏-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ckb_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ckb_Arab.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_Arab = goog.i18n.NumberFormatSymbols_ckb;


/**
 * Number formatting symbols for locale ckb_Arab_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_Arab_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_u_nu_latn;


/**
 * Number formatting symbols for locale ckb_Arab_IQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_Arab_IQ = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '‏+',
  MINUS_SIGN: '‏-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ckb_Arab_IQ_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_Arab_IQ_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ckb_Arab_IR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_Arab_IR = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '‏+',
  MINUS_SIGN: '‏-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale ckb_Arab_IR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_Arab_IR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale ckb_IQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_IQ = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '‏+',
  MINUS_SIGN: '‏-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ckb_IQ_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_IQ_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale ckb_IR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_IR = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '‏+',
  MINUS_SIGN: '‏-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale ckb_IR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ckb_IR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale cs_CZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_cs_CZ = goog.i18n.NumberFormatSymbols_cs;


/**
 * Number formatting symbols for locale cv.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_cv = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'RUB'
};


/**
 * Number formatting symbols for locale cv_RU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_cv_RU = goog.i18n.NumberFormatSymbols_cv;


/**
 * Number formatting symbols for locale cy_GB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_cy_GB = goog.i18n.NumberFormatSymbols_cy;


/**
 * Number formatting symbols for locale da_DK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_da_DK = goog.i18n.NumberFormatSymbols_da;


/**
 * Number formatting symbols for locale da_GL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_da_GL = goog.i18n.NumberFormatSymbols_da;


/**
 * Number formatting symbols for locale dav.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dav = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale dav_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dav_KE = goog.i18n.NumberFormatSymbols_dav;


/**
 * Number formatting symbols for locale de_BE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_de_BE = goog.i18n.NumberFormatSymbols_de;


/**
 * Number formatting symbols for locale de_DE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_de_DE = goog.i18n.NumberFormatSymbols_de;


/**
 * Number formatting symbols for locale de_IT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_de_IT = goog.i18n.NumberFormatSymbols_de;


/**
 * Number formatting symbols for locale de_LI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_de_LI = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '’',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale de_LU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_de_LU = goog.i18n.NumberFormatSymbols_de;


/**
 * Number formatting symbols for locale dje.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dje = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale dje_NE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dje_NE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale doi.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_doi = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale doi_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_doi_IN = goog.i18n.NumberFormatSymbols_doi;


/**
 * Number formatting symbols for locale dsb.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dsb = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale dsb_DE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dsb_DE = goog.i18n.NumberFormatSymbols_dsb;


/**
 * Number formatting symbols for locale dua.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dua = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale dua_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dua_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale dyo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dyo = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale dyo_SN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dyo_SN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale dz.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dz = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '༠',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: 'གྲངས་མེད',
  NAN: 'ཨང་མད',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0 %',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'BTN'
};


/**
 * Number formatting symbols for locale dz_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dz_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0 %',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'BTN'
};


/**
 * Number formatting symbols for locale dz_BT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dz_BT = goog.i18n.NumberFormatSymbols_dz;


/**
 * Number formatting symbols for locale dz_BT_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_dz_BT_u_nu_latn = goog.i18n.NumberFormatSymbols_dz_u_nu_latn;


/**
 * Number formatting symbols for locale ebu.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ebu = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale ebu_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ebu_KE = goog.i18n.NumberFormatSymbols_ebu;


/**
 * Number formatting symbols for locale ee.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ee = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'mnn',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale ee_GH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ee_GH = goog.i18n.NumberFormatSymbols_ee;


/**
 * Number formatting symbols for locale ee_TG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ee_TG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'mnn',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale el_CY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_el_CY = goog.i18n.NumberFormatSymbols_el;


/**
 * Number formatting symbols for locale el_GR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_el_GR = goog.i18n.NumberFormatSymbols_el;


/**
 * Number formatting symbols for locale en_001.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_001 = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_150.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_150 = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale en_AE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_AE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AED'
};


/**
 * Number formatting symbols for locale en_AG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_AG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_AI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_AI = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_AS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_AS = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_AT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_AT = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_BB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BB = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BBD'
};


/**
 * Number formatting symbols for locale en_BE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_BI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BI = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'BIF'
};


/**
 * Number formatting symbols for locale en_BM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BMD'
};


/**
 * Number formatting symbols for locale en_BS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BS = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BSD'
};


/**
 * Number formatting symbols for locale en_BW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BW = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BWP'
};


/**
 * Number formatting symbols for locale en_BZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_BZ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BZD'
};


/**
 * Number formatting symbols for locale en_CC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_CC = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AUD'
};


/**
 * Number formatting symbols for locale en_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_CH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '’',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤-#,##0.00',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale en_CK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_CK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NZD'
};


/**
 * Number formatting symbols for locale en_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_CM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale en_CX.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_CX = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AUD'
};


/**
 * Number formatting symbols for locale en_CY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_CY = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_DE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_DE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_DG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_DG = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_DK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_DK = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'DKK'
};


/**
 * Number formatting symbols for locale en_DM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_DM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_ER.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_ER = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ERN'
};


/**
 * Number formatting symbols for locale en_FI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_FI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_FJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_FJ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'FJD'
};


/**
 * Number formatting symbols for locale en_FK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_FK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'FKP'
};


/**
 * Number formatting symbols for locale en_FM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_FM = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_GD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GD = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_GG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale en_GH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale en_GI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GI = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GIP'
};


/**
 * Number formatting symbols for locale en_GM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GMD'
};


/**
 * Number formatting symbols for locale en_GU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GU = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_GY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_GY = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GYD'
};


/**
 * Number formatting symbols for locale en_HK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_HK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'HKD'
};


/**
 * Number formatting symbols for locale en_IL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_IL = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ILS'
};


/**
 * Number formatting symbols for locale en_IM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_IM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale en_IO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_IO = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_JE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_JE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale en_JM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_JM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'JMD'
};


/**
 * Number formatting symbols for locale en_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_KE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale en_KI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_KI = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AUD'
};


/**
 * Number formatting symbols for locale en_KN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_KN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_KY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_KY = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KYD'
};


/**
 * Number formatting symbols for locale en_LC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_LC = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_LR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_LR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'LRD'
};


/**
 * Number formatting symbols for locale en_LS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_LS = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ZAR'
};


/**
 * Number formatting symbols for locale en_MG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'MGA'
};


/**
 * Number formatting symbols for locale en_MH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MH = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_MO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MO = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'MOP'
};


/**
 * Number formatting symbols for locale en_MP.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MP = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_MS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MS = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_MT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MT = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_MU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MU = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'MUR'
};


/**
 * Number formatting symbols for locale en_MV.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MV = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MVR'
};


/**
 * Number formatting symbols for locale en_MW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MW = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'MWK'
};


/**
 * Number formatting symbols for locale en_MY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_MY = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'MYR'
};


/**
 * Number formatting symbols for locale en_NA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NA = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NAD'
};


/**
 * Number formatting symbols for locale en_NF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NF = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AUD'
};


/**
 * Number formatting symbols for locale en_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale en_NL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NL = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_NR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AUD'
};


/**
 * Number formatting symbols for locale en_NU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NU = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NZD'
};


/**
 * Number formatting symbols for locale en_NZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_NZ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NZD'
};


/**
 * Number formatting symbols for locale en_PG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_PG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'PGK'
};


/**
 * Number formatting symbols for locale en_PH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_PH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'PHP'
};


/**
 * Number formatting symbols for locale en_PK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_PK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale en_PN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_PN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NZD'
};


/**
 * Number formatting symbols for locale en_PR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_PR = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_PW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_PW = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_RW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_RW = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'RWF'
};


/**
 * Number formatting symbols for locale en_SB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SB = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SBD'
};


/**
 * Number formatting symbols for locale en_SC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SC = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SCR'
};


/**
 * Number formatting symbols for locale en_SD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SD = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SDG'
};


/**
 * Number formatting symbols for locale en_SE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '×10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SEK'
};


/**
 * Number formatting symbols for locale en_SH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SHP'
};


/**
 * Number formatting symbols for locale en_SI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'e',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale en_SL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SL = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SLE'
};


/**
 * Number formatting symbols for locale en_SS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SS = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SSP'
};


/**
 * Number formatting symbols for locale en_SX.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SX = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ANG'
};


/**
 * Number formatting symbols for locale en_SZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_SZ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SZL'
};


/**
 * Number formatting symbols for locale en_TC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_TC = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_TK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_TK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NZD'
};


/**
 * Number formatting symbols for locale en_TO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_TO = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TOP'
};


/**
 * Number formatting symbols for locale en_TT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_TT = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TTD'
};


/**
 * Number formatting symbols for locale en_TV.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_TV = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'AUD'
};


/**
 * Number formatting symbols for locale en_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_TZ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale en_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale en_UM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_UM = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_US_POSIX.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_US_POSIX = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '0/00',
  INFINITY: 'INF',
  NAN: 'NaN',
  DECIMAL_PATTERN: '0.######',
  SCIENTIFIC_PATTERN: '0.000000E+000',
  PERCENT_PATTERN: '0%',
  CURRENCY_PATTERN: '¤ 0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale en_VC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_VC = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XCD'
};


/**
 * Number formatting symbols for locale en_VG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_VG = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_VI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_VI = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_VU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_VU = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'VUV'
};


/**
 * Number formatting symbols for locale en_WS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_WS = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'WST'
};


/**
 * Number formatting symbols for locale en_XA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_XA = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale en_ZM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_ZM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ZMW'
};


/**
 * Number formatting symbols for locale en_ZW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_en_ZW = goog.i18n.NumberFormatSymbols_en;


/**
 * Number formatting symbols for locale eo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_eo = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale eo_001.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_eo_001 = goog.i18n.NumberFormatSymbols_eo;


/**
 * Number formatting symbols for locale es_AR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_AR = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'ARS'
};


/**
 * Number formatting symbols for locale es_BO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_BO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BOB'
};


/**
 * Number formatting symbols for locale es_BR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_BR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BRL'
};


/**
 * Number formatting symbols for locale es_BZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_BZ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'BZD'
};


/**
 * Number formatting symbols for locale es_CL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_CL = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0;¤-#,##0',
  DEF_CURRENCY_CODE: 'CLP'
};


/**
 * Number formatting symbols for locale es_CO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_CO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'COP'
};


/**
 * Number formatting symbols for locale es_CR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_CR = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'CRC'
};


/**
 * Number formatting symbols for locale es_CU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_CU = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'CUP'
};


/**
 * Number formatting symbols for locale es_DO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_DO = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'DOP'
};


/**
 * Number formatting symbols for locale es_EA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_EA = goog.i18n.NumberFormatSymbols_es;


/**
 * Number formatting symbols for locale es_EC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_EC = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00;¤-#,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale es_GQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_GQ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale es_GT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_GT = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GTQ'
};


/**
 * Number formatting symbols for locale es_HN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_HN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'HNL'
};


/**
 * Number formatting symbols for locale es_IC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_IC = goog.i18n.NumberFormatSymbols_es;


/**
 * Number formatting symbols for locale es_NI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_NI = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NIO'
};


/**
 * Number formatting symbols for locale es_PA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_PA = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'PAB'
};


/**
 * Number formatting symbols for locale es_PE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_PE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PEN'
};


/**
 * Number formatting symbols for locale es_PH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_PH = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'PHP'
};


/**
 * Number formatting symbols for locale es_PR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_PR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale es_PY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_PY = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0;¤ -#,##0',
  DEF_CURRENCY_CODE: 'PYG'
};


/**
 * Number formatting symbols for locale es_SV.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_SV = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale es_UY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_UY = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'UYU'
};


/**
 * Number formatting symbols for locale es_VE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_es_VE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00;¤-#,##0.00',
  DEF_CURRENCY_CODE: 'VES'
};


/**
 * Number formatting symbols for locale et_EE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_et_EE = goog.i18n.NumberFormatSymbols_et;


/**
 * Number formatting symbols for locale eu_ES.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_eu_ES = goog.i18n.NumberFormatSymbols_eu;


/**
 * Number formatting symbols for locale ewo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ewo = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ewo_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ewo_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fa_AF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fa_AF = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ناعدد',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale fa_AF_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fa_AF_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ناعدد',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale fa_IR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fa_IR = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'ناعدد',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‎¤#,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale fa_IR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fa_IR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ناعدد',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '‎¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale ff.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GNF'
};


/**
 * Number formatting symbols for locale ff_Adlm_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GNF'
};


/**
 * Number formatting symbols for locale ff_Adlm_BF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_BF = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_BF_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_BF_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_CM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ff_Adlm_CM_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_CM_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ff_Adlm_GH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale ff_Adlm_GH_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GH_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale ff_Adlm_GM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GMD'
};


/**
 * Number formatting symbols for locale ff_Adlm_GM_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GM_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GMD'
};


/**
 * Number formatting symbols for locale ff_Adlm_GN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'GNF'
};


/**
 * Number formatting symbols for locale ff_Adlm_GN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GN_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'GNF'
};


/**
 * Number formatting symbols for locale ff_Adlm_GW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GW = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_GW_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_GW_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_LR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_LR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'LRD'
};


/**
 * Number formatting symbols for locale ff_Adlm_LR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_LR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'LRD'
};


/**
 * Number formatting symbols for locale ff_Adlm_MR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_MR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MRU'
};


/**
 * Number formatting symbols for locale ff_Adlm_MR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_MR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MRU'
};


/**
 * Number formatting symbols for locale ff_Adlm_NE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_NE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_NE_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_NE_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_NG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale ff_Adlm_NG_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_NG_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale ff_Adlm_SL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_SL = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'SLE'
};


/**
 * Number formatting symbols for locale ff_Adlm_SL_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_SL_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'SLE'
};


/**
 * Number formatting symbols for locale ff_Adlm_SN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_SN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: '𞤉',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Adlm_SN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Adlm_SN_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '⹁',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn = goog.i18n.NumberFormatSymbols_ff;


/**
 * Number formatting symbols for locale ff_Latn_BF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_BF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Latn_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ff_Latn_GH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_GH = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale ff_Latn_GM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_GM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'GMD'
};


/**
 * Number formatting symbols for locale ff_Latn_GN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_GN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'GNF'
};


/**
 * Number formatting symbols for locale ff_Latn_GW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_GW = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Latn_LR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_LR = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'LRD'
};


/**
 * Number formatting symbols for locale ff_Latn_MR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_MR = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MRU'
};


/**
 * Number formatting symbols for locale ff_Latn_NE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_NE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ff_Latn_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_NG = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale ff_Latn_SL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_SL = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SLE'
};


/**
 * Number formatting symbols for locale ff_Latn_SN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ff_Latn_SN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fi_FI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fi_FI = goog.i18n.NumberFormatSymbols_fi;


/**
 * Number formatting symbols for locale fil_PH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fil_PH = goog.i18n.NumberFormatSymbols_fil;


/**
 * Number formatting symbols for locale fo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fo = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'DKK'
};


/**
 * Number formatting symbols for locale fo_DK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fo_DK = goog.i18n.NumberFormatSymbols_fo;


/**
 * Number formatting symbols for locale fo_FO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fo_FO = goog.i18n.NumberFormatSymbols_fo;


/**
 * Number formatting symbols for locale fr_BE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_BE = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_BF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_BF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_BI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_BI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'BIF'
};


/**
 * Number formatting symbols for locale fr_BJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_BJ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_BL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_BL = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_CD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_CD = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'CDF'
};


/**
 * Number formatting symbols for locale fr_CF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_CF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fr_CG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_CG = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fr_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_CH = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale fr_CI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_CI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fr_DJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_DJ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'DJF'
};


/**
 * Number formatting symbols for locale fr_DZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_DZ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'DZD'
};


/**
 * Number formatting symbols for locale fr_FR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_FR = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_GA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_GA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fr_GF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_GF = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_GN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_GN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'GNF'
};


/**
 * Number formatting symbols for locale fr_GP.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_GP = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_GQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_GQ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fr_HT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_HT = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'HTG'
};


/**
 * Number formatting symbols for locale fr_KM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_KM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'KMF'
};


/**
 * Number formatting symbols for locale fr_LU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_LU = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale fr_MA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MAD'
};


/**
 * Number formatting symbols for locale fr_MC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MC = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_MF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MF = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_MG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MG = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'MGA'
};


/**
 * Number formatting symbols for locale fr_ML.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_ML = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_MQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MQ = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_MR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MR = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MRU'
};


/**
 * Number formatting symbols for locale fr_MU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_MU = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MUR'
};


/**
 * Number formatting symbols for locale fr_NC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_NC = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XPF'
};


/**
 * Number formatting symbols for locale fr_NE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_NE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_PF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_PF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XPF'
};


/**
 * Number formatting symbols for locale fr_PM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_PM = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_RE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_RE = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fr_RW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_RW = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'RWF'
};


/**
 * Number formatting symbols for locale fr_SC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_SC = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SCR'
};


/**
 * Number formatting symbols for locale fr_SN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_SN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_SY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_SY = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'SYP'
};


/**
 * Number formatting symbols for locale fr_TD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_TD = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale fr_TG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_TG = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale fr_TN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_TN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.000 ¤',
  DEF_CURRENCY_CODE: 'TND'
};


/**
 * Number formatting symbols for locale fr_VU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_VU = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'VUV'
};


/**
 * Number formatting symbols for locale fr_WF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_WF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XPF'
};


/**
 * Number formatting symbols for locale fr_YT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fr_YT = goog.i18n.NumberFormatSymbols_fr;


/**
 * Number formatting symbols for locale fur.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fur = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale fur_IT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fur_IT = goog.i18n.NumberFormatSymbols_fur;


/**
 * Number formatting symbols for locale fy.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fy = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤ #,##0.00-',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale fy_NL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_fy_NL = goog.i18n.NumberFormatSymbols_fy;


/**
 * Number formatting symbols for locale ga_GB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ga_GB = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'Nuimh',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale ga_IE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ga_IE = goog.i18n.NumberFormatSymbols_ga;


/**
 * Number formatting symbols for locale gd.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gd = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale gd_GB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gd_GB = goog.i18n.NumberFormatSymbols_gd;


/**
 * Number formatting symbols for locale gl_ES.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gl_ES = goog.i18n.NumberFormatSymbols_gl;


/**
 * Number formatting symbols for locale gsw_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gsw_CH = goog.i18n.NumberFormatSymbols_gsw;


/**
 * Number formatting symbols for locale gsw_FR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gsw_FR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '’',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale gsw_LI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gsw_LI = goog.i18n.NumberFormatSymbols_gsw;


/**
 * Number formatting symbols for locale gu_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gu_IN = goog.i18n.NumberFormatSymbols_gu;


/**
 * Number formatting symbols for locale guz.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_guz = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale guz_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_guz_KE = goog.i18n.NumberFormatSymbols_guz;


/**
 * Number formatting symbols for locale gv.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gv = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale gv_IM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_gv_IM = goog.i18n.NumberFormatSymbols_gv;


/**
 * Number formatting symbols for locale ha.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ha = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale ha_GH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ha_GH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GHS'
};


/**
 * Number formatting symbols for locale ha_NE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ha_NE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ha_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ha_NG = goog.i18n.NumberFormatSymbols_ha;


/**
 * Number formatting symbols for locale haw_US.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_haw_US = goog.i18n.NumberFormatSymbols_haw;


/**
 * Number formatting symbols for locale he_IL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_he_IL = goog.i18n.NumberFormatSymbols_he;


/**
 * Number formatting symbols for locale hi_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hi_IN = goog.i18n.NumberFormatSymbols_hi;


/**
 * Number formatting symbols for locale hi_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hi_Latn = goog.i18n.NumberFormatSymbols_hi;


/**
 * Number formatting symbols for locale hi_Latn_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hi_Latn_IN = goog.i18n.NumberFormatSymbols_hi;


/**
 * Number formatting symbols for locale hr_BA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hr_BA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'BAM'
};


/**
 * Number formatting symbols for locale hr_HR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hr_HR = goog.i18n.NumberFormatSymbols_hr;


/**
 * Number formatting symbols for locale hsb.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hsb = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale hsb_DE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hsb_DE = goog.i18n.NumberFormatSymbols_hsb;


/**
 * Number formatting symbols for locale hu_HU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hu_HU = goog.i18n.NumberFormatSymbols_hu;


/**
 * Number formatting symbols for locale hy_AM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_hy_AM = goog.i18n.NumberFormatSymbols_hy;


/**
 * Number formatting symbols for locale ia.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ia = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale ia_001.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ia_001 = goog.i18n.NumberFormatSymbols_ia;


/**
 * Number formatting symbols for locale id_ID.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_id_ID = goog.i18n.NumberFormatSymbols_id;


/**
 * Number formatting symbols for locale ig.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ig = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale ig_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ig_NG = goog.i18n.NumberFormatSymbols_ig;


/**
 * Number formatting symbols for locale ii.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ii = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'CNY'
};


/**
 * Number formatting symbols for locale ii_CN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ii_CN = goog.i18n.NumberFormatSymbols_ii;


/**
 * Number formatting symbols for locale is_IS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_is_IS = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'ISK'
};


/**
 * Number formatting symbols for locale it_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_it_CH = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '’',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤-#,##0.00',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale it_IT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_it_IT = goog.i18n.NumberFormatSymbols_it;


/**
 * Number formatting symbols for locale it_SM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_it_SM = goog.i18n.NumberFormatSymbols_it;


/**
 * Number formatting symbols for locale it_VA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_it_VA = goog.i18n.NumberFormatSymbols_it;


/**
 * Number formatting symbols for locale ja_JP.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ja_JP = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'JPY'
};


/**
 * Number formatting symbols for locale jgo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_jgo = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale jgo_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_jgo_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale jmc.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_jmc = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale jmc_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_jmc_TZ = goog.i18n.NumberFormatSymbols_jmc;


/**
 * Number formatting symbols for locale jv.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_jv = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'IDR'
};


/**
 * Number formatting symbols for locale jv_ID.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_jv_ID = goog.i18n.NumberFormatSymbols_jv;


/**
 * Number formatting symbols for locale ka_GE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ka_GE = goog.i18n.NumberFormatSymbols_ka;


/**
 * Number formatting symbols for locale kab.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kab = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'DZD'
};


/**
 * Number formatting symbols for locale kab_DZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kab_DZ = goog.i18n.NumberFormatSymbols_kab;


/**
 * Number formatting symbols for locale kam.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kam = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale kam_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kam_KE = goog.i18n.NumberFormatSymbols_kam;


/**
 * Number formatting symbols for locale kde.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kde = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale kde_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kde_TZ = goog.i18n.NumberFormatSymbols_kde;


/**
 * Number formatting symbols for locale kea.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kea = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'CVE'
};


/**
 * Number formatting symbols for locale kea_CV.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kea_CV = goog.i18n.NumberFormatSymbols_kea;


/**
 * Number formatting symbols for locale kgp.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kgp = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'BRL'
};


/**
 * Number formatting symbols for locale kgp_BR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kgp_BR = goog.i18n.NumberFormatSymbols_kgp;


/**
 * Number formatting symbols for locale khq.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_khq = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale khq_ML.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_khq_ML = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ki.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ki = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale ki_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ki_KE = goog.i18n.NumberFormatSymbols_ki;


/**
 * Number formatting symbols for locale kk_KZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kk_KZ = goog.i18n.NumberFormatSymbols_kk;


/**
 * Number formatting symbols for locale kkj.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kkj = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale kkj_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kkj_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale kl.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kl = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤#,##0.00;¤-#,##0.00',
  DEF_CURRENCY_CODE: 'DKK'
};


/**
 * Number formatting symbols for locale kl_GL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kl_GL = goog.i18n.NumberFormatSymbols_kl;


/**
 * Number formatting symbols for locale kln.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kln = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale kln_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kln_KE = goog.i18n.NumberFormatSymbols_kln;


/**
 * Number formatting symbols for locale km_KH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_km_KH = goog.i18n.NumberFormatSymbols_km;


/**
 * Number formatting symbols for locale kn_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kn_IN = goog.i18n.NumberFormatSymbols_kn;


/**
 * Number formatting symbols for locale ko_KP.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ko_KP = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'KPW'
};


/**
 * Number formatting symbols for locale ko_KR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ko_KR = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'KRW'
};


/**
 * Number formatting symbols for locale kok.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kok = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale kok_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kok_IN = goog.i18n.NumberFormatSymbols_kok;


/**
 * Number formatting symbols for locale ks.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ks_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '،',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ks_Arab.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_Arab = goog.i18n.NumberFormatSymbols_ks;


/**
 * Number formatting symbols for locale ks_Arab_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_Arab_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_u_nu_latn;


/**
 * Number formatting symbols for locale ks_Arab_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_Arab_IN = goog.i18n.NumberFormatSymbols_ks;


/**
 * Number formatting symbols for locale ks_Arab_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_Arab_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_u_nu_latn;


/**
 * Number formatting symbols for locale ks_Deva.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_Deva = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ks_Deva_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ks_Deva_IN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ksb.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ksb = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale ksb_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ksb_TZ = goog.i18n.NumberFormatSymbols_ksb;


/**
 * Number formatting symbols for locale ksf.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ksf = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ksf_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ksf_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ksh.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ksh = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: '×10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale ksh_DE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ksh_DE = goog.i18n.NumberFormatSymbols_ksh;


/**
 * Number formatting symbols for locale ku.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ku = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '%#,##0',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'TRY'
};


/**
 * Number formatting symbols for locale ku_TR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ku_TR = goog.i18n.NumberFormatSymbols_ku;


/**
 * Number formatting symbols for locale kw.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kw = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'GBP'
};


/**
 * Number formatting symbols for locale kw_GB.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_kw_GB = goog.i18n.NumberFormatSymbols_kw;


/**
 * Number formatting symbols for locale ky_KG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ky_KG = goog.i18n.NumberFormatSymbols_ky;


/**
 * Number formatting symbols for locale lag.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lag = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale lag_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lag_TZ = goog.i18n.NumberFormatSymbols_lag;


/**
 * Number formatting symbols for locale lb.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lb = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale lb_LU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lb_LU = goog.i18n.NumberFormatSymbols_lb;


/**
 * Number formatting symbols for locale lg.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lg = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale lg_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lg_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale lkt.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lkt = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale lkt_US.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lkt_US = goog.i18n.NumberFormatSymbols_lkt;


/**
 * Number formatting symbols for locale ln_AO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ln_AO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'AOA'
};


/**
 * Number formatting symbols for locale ln_CD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ln_CD = goog.i18n.NumberFormatSymbols_ln;


/**
 * Number formatting symbols for locale ln_CF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ln_CF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale ln_CG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ln_CG = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale lo_LA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lo_LA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ບໍ່​ແມ່ນ​ໂຕ​ເລກ',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0;¤-#,##0',
  DEF_CURRENCY_CODE: 'LAK'
};


/**
 * Number formatting symbols for locale lrc.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lrc = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale lrc_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lrc_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale lrc_IQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lrc_IQ = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale lrc_IQ_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lrc_IQ_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IQD'
};


/**
 * Number formatting symbols for locale lrc_IR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lrc_IR = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale lrc_IR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lrc_IR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale lt_LT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lt_LT = goog.i18n.NumberFormatSymbols_lt;


/**
 * Number formatting symbols for locale lu.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lu = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'CDF'
};


/**
 * Number formatting symbols for locale lu_CD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lu_CD = goog.i18n.NumberFormatSymbols_lu;


/**
 * Number formatting symbols for locale luo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_luo = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale luo_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_luo_KE = goog.i18n.NumberFormatSymbols_luo;


/**
 * Number formatting symbols for locale luy.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_luy = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00;¤- #,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale luy_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_luy_KE = goog.i18n.NumberFormatSymbols_luy;


/**
 * Number formatting symbols for locale lv_LV.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_lv_LV = goog.i18n.NumberFormatSymbols_lv;


/**
 * Number formatting symbols for locale mai.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mai = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '[#E0]',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale mai_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mai_IN = goog.i18n.NumberFormatSymbols_mai;


/**
 * Number formatting symbols for locale mas.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mas = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale mas_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mas_KE = goog.i18n.NumberFormatSymbols_mas;


/**
 * Number formatting symbols for locale mas_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mas_TZ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale mer.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mer = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale mer_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mer_KE = goog.i18n.NumberFormatSymbols_mer;


/**
 * Number formatting symbols for locale mfe.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mfe = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MUR'
};


/**
 * Number formatting symbols for locale mfe_MU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mfe_MU = goog.i18n.NumberFormatSymbols_mfe;


/**
 * Number formatting symbols for locale mg.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mg = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MGA'
};


/**
 * Number formatting symbols for locale mg_MG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mg_MG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'MGA'
};


/**
 * Number formatting symbols for locale mgh.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mgh = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MZN'
};


/**
 * Number formatting symbols for locale mgh_MZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mgh_MZ = goog.i18n.NumberFormatSymbols_mgh;


/**
 * Number formatting symbols for locale mgo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mgo = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale mgo_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mgo_CM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale mi.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mi = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'NZD'
};


/**
 * Number formatting symbols for locale mi_NZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mi_NZ = goog.i18n.NumberFormatSymbols_mi;


/**
 * Number formatting symbols for locale mk_MK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mk_MK = goog.i18n.NumberFormatSymbols_mk;


/**
 * Number formatting symbols for locale ml_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ml_IN = goog.i18n.NumberFormatSymbols_ml;


/**
 * Number formatting symbols for locale mn_MN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mn_MN = goog.i18n.NumberFormatSymbols_mn;


/**
 * Number formatting symbols for locale mni.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mni = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '০',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale mni_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mni_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale mni_Beng.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mni_Beng = goog.i18n.NumberFormatSymbols_mni;


/**
 * Number formatting symbols for locale mni_Beng_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mni_Beng_u_nu_latn = goog.i18n.NumberFormatSymbols_mni_u_nu_latn;


/**
 * Number formatting symbols for locale mni_Beng_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mni_Beng_IN = goog.i18n.NumberFormatSymbols_mni;


/**
 * Number formatting symbols for locale mni_Beng_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mni_Beng_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_mni_u_nu_latn;


/**
 * Number formatting symbols for locale mr_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mr_IN = goog.i18n.NumberFormatSymbols_mr;


/**
 * Number formatting symbols for locale mr_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mr_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_mr_u_nu_latn;


/**
 * Number formatting symbols for locale ms_BN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ms_BN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'BND'
};


/**
 * Number formatting symbols for locale ms_ID.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ms_ID = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'IDR'
};


/**
 * Number formatting symbols for locale ms_MY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ms_MY = goog.i18n.NumberFormatSymbols_ms;


/**
 * Number formatting symbols for locale ms_SG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ms_SG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SGD'
};


/**
 * Number formatting symbols for locale mt_MT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mt_MT = goog.i18n.NumberFormatSymbols_mt;


/**
 * Number formatting symbols for locale mua.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mua = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale mua_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mua_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale my_MM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_my_MM = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '၀',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ဂဏန်းမဟုတ်သော',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'MMK'
};


/**
 * Number formatting symbols for locale my_MM_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_my_MM_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ဂဏန်းမဟုတ်သော',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'MMK'
};


/**
 * Number formatting symbols for locale mzn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mzn = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale mzn_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mzn_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale mzn_IR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mzn_IR = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale mzn_IR_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_mzn_IR_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'IRR'
};


/**
 * Number formatting symbols for locale naq.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_naq = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NAD'
};


/**
 * Number formatting symbols for locale naq_NA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_naq_NA = goog.i18n.NumberFormatSymbols_naq;


/**
 * Number formatting symbols for locale nb_NO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nb_NO = goog.i18n.NumberFormatSymbols_nb;


/**
 * Number formatting symbols for locale nb_SJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nb_SJ = goog.i18n.NumberFormatSymbols_nb;


/**
 * Number formatting symbols for locale nd.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nd = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale nd_ZW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nd_ZW = goog.i18n.NumberFormatSymbols_nd;


/**
 * Number formatting symbols for locale ne_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ne_IN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '०',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤ #,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ne_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ne_IN_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ne_NP.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ne_NP = goog.i18n.NumberFormatSymbols_ne;


/**
 * Number formatting symbols for locale ne_NP_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ne_NP_u_nu_latn = goog.i18n.NumberFormatSymbols_ne_u_nu_latn;


/**
 * Number formatting symbols for locale nl_AW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_AW = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤ -#,##0.00',
  DEF_CURRENCY_CODE: 'AWG'
};


/**
 * Number formatting symbols for locale nl_BE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_BE = goog.i18n.NumberFormatSymbols_nl;


/**
 * Number formatting symbols for locale nl_BQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_BQ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤ -#,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale nl_CW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_CW = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤ -#,##0.00',
  DEF_CURRENCY_CODE: 'ANG'
};


/**
 * Number formatting symbols for locale nl_NL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_NL = goog.i18n.NumberFormatSymbols_nl;


/**
 * Number formatting symbols for locale nl_SR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_SR = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤ -#,##0.00',
  DEF_CURRENCY_CODE: 'SRD'
};


/**
 * Number formatting symbols for locale nl_SX.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nl_SX = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00;¤ -#,##0.00',
  DEF_CURRENCY_CODE: 'ANG'
};


/**
 * Number formatting symbols for locale nmg.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nmg = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale nmg_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nmg_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale nn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'NOK'
};


/**
 * Number formatting symbols for locale nn_NO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nn_NO = goog.i18n.NumberFormatSymbols_nn;


/**
 * Number formatting symbols for locale nnh.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nnh = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale nnh_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nnh_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale nus.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nus = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SSP'
};


/**
 * Number formatting symbols for locale nus_SS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nus_SS = goog.i18n.NumberFormatSymbols_nus;


/**
 * Number formatting symbols for locale nyn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nyn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale nyn_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_nyn_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale om.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_om = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ETB'
};


/**
 * Number formatting symbols for locale om_ET.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_om_ET = goog.i18n.NumberFormatSymbols_om;


/**
 * Number formatting symbols for locale om_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_om_KE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale or_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_or_IN = goog.i18n.NumberFormatSymbols_or;


/**
 * Number formatting symbols for locale os.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_os = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'НН',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'GEL'
};


/**
 * Number formatting symbols for locale os_GE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_os_GE = goog.i18n.NumberFormatSymbols_os;


/**
 * Number formatting symbols for locale os_RU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_os_RU = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'НН',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'RUB'
};


/**
 * Number formatting symbols for locale pa_Arab.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pa_Arab = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale pa_Arab_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pa_Arab_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale pa_Arab_PK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pa_Arab_PK = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale pa_Arab_PK_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pa_Arab_PK_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale pa_Guru.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pa_Guru = goog.i18n.NumberFormatSymbols_pa;


/**
 * Number formatting symbols for locale pa_Guru_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pa_Guru_IN = goog.i18n.NumberFormatSymbols_pa;


/**
 * Number formatting symbols for locale pcm.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pcm = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale pcm_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pcm_NG = goog.i18n.NumberFormatSymbols_pcm;


/**
 * Number formatting symbols for locale pl_PL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pl_PL = goog.i18n.NumberFormatSymbols_pl;


/**
 * Number formatting symbols for locale ps.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ps = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale ps_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ps_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale ps_AF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ps_AF = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale ps_AF_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ps_AF_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale ps_PK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ps_PK = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale ps_PK_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ps_PK_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale pt_AO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_AO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'AOA'
};


/**
 * Number formatting symbols for locale pt_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_CH = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale pt_CV.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_CV = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'CVE'
};


/**
 * Number formatting symbols for locale pt_GQ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_GQ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale pt_GW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_GW = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale pt_LU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_LU = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale pt_MO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_MO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MOP'
};


/**
 * Number formatting symbols for locale pt_MZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_MZ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MZN'
};


/**
 * Number formatting symbols for locale pt_ST.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_ST = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'STN'
};


/**
 * Number formatting symbols for locale pt_TL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_pt_TL = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale qu.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_qu = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PEN'
};


/**
 * Number formatting symbols for locale qu_BO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_qu_BO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'BOB'
};


/**
 * Number formatting symbols for locale qu_EC.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_qu_EC = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale qu_PE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_qu_PE = goog.i18n.NumberFormatSymbols_qu;


/**
 * Number formatting symbols for locale raj.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_raj = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '०',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale raj_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_raj_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale raj_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_raj_IN = goog.i18n.NumberFormatSymbols_raj;


/**
 * Number formatting symbols for locale raj_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_raj_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_raj_u_nu_latn;


/**
 * Number formatting symbols for locale rm.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rm = {
  DECIMAL_SEP: '.',
  GROUP_SEP: '’',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale rm_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rm_CH = goog.i18n.NumberFormatSymbols_rm;


/**
 * Number formatting symbols for locale rn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'BIF'
};


/**
 * Number formatting symbols for locale rn_BI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rn_BI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'BIF'
};


/**
 * Number formatting symbols for locale ro_MD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ro_MD = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MDL'
};


/**
 * Number formatting symbols for locale ro_RO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ro_RO = goog.i18n.NumberFormatSymbols_ro;


/**
 * Number formatting symbols for locale rof.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rof = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale rof_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rof_TZ = goog.i18n.NumberFormatSymbols_rof;


/**
 * Number formatting symbols for locale ru_BY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ru_BY = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'не число',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'BYN'
};


/**
 * Number formatting symbols for locale ru_KG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ru_KG = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'не число',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'KGS'
};


/**
 * Number formatting symbols for locale ru_KZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ru_KZ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'не число',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'KZT'
};


/**
 * Number formatting symbols for locale ru_MD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ru_MD = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'не число',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MDL'
};


/**
 * Number formatting symbols for locale ru_RU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ru_RU = goog.i18n.NumberFormatSymbols_ru;


/**
 * Number formatting symbols for locale ru_UA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ru_UA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'не число',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'UAH'
};


/**
 * Number formatting symbols for locale rw.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rw = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'RWF'
};


/**
 * Number formatting symbols for locale rw_RW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rw_RW = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'RWF'
};


/**
 * Number formatting symbols for locale rwk.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rwk = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale rwk_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_rwk_TZ = goog.i18n.NumberFormatSymbols_rwk;


/**
 * Number formatting symbols for locale sa.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sa = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '०',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '[#E0]',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale sa_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sa_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '[#E0]',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale sa_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sa_IN = goog.i18n.NumberFormatSymbols_sa;


/**
 * Number formatting symbols for locale sa_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sa_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_sa_u_nu_latn;


/**
 * Number formatting symbols for locale sah.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sah = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'чыыһыла буотах',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'RUB'
};


/**
 * Number formatting symbols for locale sah_RU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sah_RU = goog.i18n.NumberFormatSymbols_sah;


/**
 * Number formatting symbols for locale saq.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_saq = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale saq_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_saq_KE = goog.i18n.NumberFormatSymbols_saq;


/**
 * Number formatting symbols for locale sat.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sat = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '᱐',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale sat_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sat_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale sat_Olck.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sat_Olck = goog.i18n.NumberFormatSymbols_sat;


/**
 * Number formatting symbols for locale sat_Olck_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sat_Olck_u_nu_latn = goog.i18n.NumberFormatSymbols_sat_u_nu_latn;


/**
 * Number formatting symbols for locale sat_Olck_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sat_Olck_IN = goog.i18n.NumberFormatSymbols_sat;


/**
 * Number formatting symbols for locale sat_Olck_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sat_Olck_IN_u_nu_latn = goog.i18n.NumberFormatSymbols_sat_u_nu_latn;


/**
 * Number formatting symbols for locale sbp.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sbp = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale sbp_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sbp_TZ = goog.i18n.NumberFormatSymbols_sbp;


/**
 * Number formatting symbols for locale sc.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sc = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sc_IT.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sc_IT = goog.i18n.NumberFormatSymbols_sc;


/**
 * Number formatting symbols for locale sd.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪؜',
  ZERO_DIGIT: '٠',
  PLUS_SIGN: '؜+',
  MINUS_SIGN: '؜-',
  EXP_SYMBOL: 'اس',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale sd_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'PKR'
};


/**
 * Number formatting symbols for locale sd_Arab.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_Arab = goog.i18n.NumberFormatSymbols_sd;


/**
 * Number formatting symbols for locale sd_Arab_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_Arab_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_u_nu_latn;


/**
 * Number formatting symbols for locale sd_Arab_PK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_Arab_PK = goog.i18n.NumberFormatSymbols_sd;


/**
 * Number formatting symbols for locale sd_Arab_PK_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_Arab_PK_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_u_nu_latn;


/**
 * Number formatting symbols for locale sd_Deva.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_Deva = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale sd_Deva_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sd_Deva_IN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale se.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_se = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: '·10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'NOK'
};


/**
 * Number formatting symbols for locale se_FI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_se_FI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: '·10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale se_NO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_se_NO = goog.i18n.NumberFormatSymbols_se;


/**
 * Number formatting symbols for locale se_SE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_se_SE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: '·10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'SEK'
};


/**
 * Number formatting symbols for locale seh.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_seh = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'MZN'
};


/**
 * Number formatting symbols for locale seh_MZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_seh_MZ = goog.i18n.NumberFormatSymbols_seh;


/**
 * Number formatting symbols for locale ses.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ses = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale ses_ML.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ses_ML = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale sg.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sg = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00;¤-#,##0.00',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale sg_CF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sg_CF = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0;¤-#,##0',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale shi.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_shi = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'MAD'
};


/**
 * Number formatting symbols for locale shi_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_shi_Latn = goog.i18n.NumberFormatSymbols_shi;


/**
 * Number formatting symbols for locale shi_Latn_MA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_shi_Latn_MA = goog.i18n.NumberFormatSymbols_shi;


/**
 * Number formatting symbols for locale shi_Tfng.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_shi_Tfng = goog.i18n.NumberFormatSymbols_shi;


/**
 * Number formatting symbols for locale shi_Tfng_MA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_shi_Tfng_MA = goog.i18n.NumberFormatSymbols_shi;


/**
 * Number formatting symbols for locale si_LK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_si_LK = goog.i18n.NumberFormatSymbols_si;


/**
 * Number formatting symbols for locale sk_SK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sk_SK = goog.i18n.NumberFormatSymbols_sk;


/**
 * Number formatting symbols for locale sl_SI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sl_SI = goog.i18n.NumberFormatSymbols_sl;


/**
 * Number formatting symbols for locale smn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_smn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'epiloho',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale smn_FI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_smn_FI = goog.i18n.NumberFormatSymbols_smn;


/**
 * Number formatting symbols for locale sn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'USD'
};


/**
 * Number formatting symbols for locale sn_ZW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sn_ZW = goog.i18n.NumberFormatSymbols_sn;


/**
 * Number formatting symbols for locale so.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_so = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'MaL',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SOS'
};


/**
 * Number formatting symbols for locale so_DJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_so_DJ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'MaL',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'DJF'
};


/**
 * Number formatting symbols for locale so_ET.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_so_ET = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'MaL',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ETB'
};


/**
 * Number formatting symbols for locale so_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_so_KE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'MaL',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale so_SO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_so_SO = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'MaL',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'SOS'
};


/**
 * Number formatting symbols for locale sq_AL.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sq_AL = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'ALL'
};


/**
 * Number formatting symbols for locale sq_MK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sq_MK = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MKD'
};


/**
 * Number formatting symbols for locale sq_XK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sq_XK = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sr_Cyrl.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Cyrl = goog.i18n.NumberFormatSymbols_sr;


/**
 * Number formatting symbols for locale sr_Cyrl_BA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Cyrl_BA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'BAM'
};


/**
 * Number formatting symbols for locale sr_Cyrl_ME.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Cyrl_ME = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sr_Cyrl_RS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Cyrl_RS = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'RSD'
};


/**
 * Number formatting symbols for locale sr_Cyrl_XK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Cyrl_XK = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sr_Latn_BA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Latn_BA = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'BAM'
};


/**
 * Number formatting symbols for locale sr_Latn_ME.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Latn_ME = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sr_Latn_RS.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Latn_RS = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'RSD'
};


/**
 * Number formatting symbols for locale sr_Latn_XK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sr_Latn_XK = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale su.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_su = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'IDR'
};


/**
 * Number formatting symbols for locale su_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_su_Latn = goog.i18n.NumberFormatSymbols_su;


/**
 * Number formatting symbols for locale su_Latn_ID.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_su_Latn_ID = goog.i18n.NumberFormatSymbols_su;


/**
 * Number formatting symbols for locale sv_AX.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sv_AX = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: '×10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sv_FI.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sv_FI = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '−',
  EXP_SYMBOL: '×10^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale sv_SE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sv_SE = goog.i18n.NumberFormatSymbols_sv;


/**
 * Number formatting symbols for locale sw_CD.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sw_CD = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'CDF'
};


/**
 * Number formatting symbols for locale sw_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sw_KE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale sw_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sw_TZ = goog.i18n.NumberFormatSymbols_sw;


/**
 * Number formatting symbols for locale sw_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_sw_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale ta_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ta_IN = goog.i18n.NumberFormatSymbols_ta;


/**
 * Number formatting symbols for locale ta_LK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ta_LK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##,##0%',
  CURRENCY_PATTERN: '¤#,##,##0.00',
  DEF_CURRENCY_CODE: 'LKR'
};


/**
 * Number formatting symbols for locale ta_MY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ta_MY = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'MYR'
};


/**
 * Number formatting symbols for locale ta_SG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ta_SG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'SGD'
};


/**
 * Number formatting symbols for locale te_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_te_IN = goog.i18n.NumberFormatSymbols_te;


/**
 * Number formatting symbols for locale teo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_teo = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale teo_KE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_teo_KE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'KES'
};


/**
 * Number formatting symbols for locale teo_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_teo_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale tg.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tg = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'TJS'
};


/**
 * Number formatting symbols for locale tg_TJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tg_TJ = goog.i18n.NumberFormatSymbols_tg;


/**
 * Number formatting symbols for locale th_TH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_th_TH = goog.i18n.NumberFormatSymbols_th;


/**
 * Number formatting symbols for locale ti.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ti = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ETB'
};


/**
 * Number formatting symbols for locale ti_ER.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ti_ER = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ERN'
};


/**
 * Number formatting symbols for locale ti_ET.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ti_ET = goog.i18n.NumberFormatSymbols_ti;


/**
 * Number formatting symbols for locale tk.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tk = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'san däl',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'TMT'
};


/**
 * Number formatting symbols for locale tk_TM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tk_TM = goog.i18n.NumberFormatSymbols_tk;


/**
 * Number formatting symbols for locale to.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_to = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'TF',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'TOP'
};


/**
 * Number formatting symbols for locale to_TO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_to_TO = goog.i18n.NumberFormatSymbols_to;


/**
 * Number formatting symbols for locale tr_CY.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tr_CY = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '%#,##0',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale tr_TR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tr_TR = goog.i18n.NumberFormatSymbols_tr;


/**
 * Number formatting symbols for locale tt.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tt = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'RUB'
};


/**
 * Number formatting symbols for locale tt_RU.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tt_RU = goog.i18n.NumberFormatSymbols_tt;


/**
 * Number formatting symbols for locale twq.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_twq = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale twq_NE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_twq_NE = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0¤',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale tzm.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tzm = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'MAD'
};


/**
 * Number formatting symbols for locale tzm_MA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_tzm_MA = goog.i18n.NumberFormatSymbols_tzm;


/**
 * Number formatting symbols for locale ug.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ug = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'CNY'
};


/**
 * Number formatting symbols for locale ug_CN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ug_CN = goog.i18n.NumberFormatSymbols_ug;


/**
 * Number formatting symbols for locale uk_UA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uk_UA = goog.i18n.NumberFormatSymbols_uk;


/**
 * Number formatting symbols for locale ur_IN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ur_IN = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '%',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ur_IN_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ur_IN_u_nu_latn = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'INR'
};


/**
 * Number formatting symbols for locale ur_PK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_ur_PK = goog.i18n.NumberFormatSymbols_ur;


/**
 * Number formatting symbols for locale uz_Arab.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Arab = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale uz_Arab_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Arab_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale uz_Arab_AF.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Arab_AF = {
  DECIMAL_SEP: '٫',
  GROUP_SEP: '٬',
  PERCENT: '٪',
  ZERO_DIGIT: '۰',
  PLUS_SIGN: '‎+‎',
  MINUS_SIGN: '‎-‎',
  EXP_SYMBOL: '×۱۰^',
  PERMILL: '؉',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale uz_Arab_AF_u_nu_latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Arab_AF_u_nu_latn = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '‎+',
  MINUS_SIGN: '‎−',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'AFN'
};


/**
 * Number formatting symbols for locale uz_Cyrl.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Cyrl = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ҳақиқий сон эмас',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'UZS'
};


/**
 * Number formatting symbols for locale uz_Cyrl_UZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Cyrl_UZ = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'ҳақиқий сон эмас',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'UZS'
};


/**
 * Number formatting symbols for locale uz_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Latn = goog.i18n.NumberFormatSymbols_uz;


/**
 * Number formatting symbols for locale uz_Latn_UZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_uz_Latn_UZ = goog.i18n.NumberFormatSymbols_uz;


/**
 * Number formatting symbols for locale vai.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vai = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'LRD'
};


/**
 * Number formatting symbols for locale vai_Latn.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vai_Latn = goog.i18n.NumberFormatSymbols_vai;


/**
 * Number formatting symbols for locale vai_Latn_LR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vai_Latn_LR = goog.i18n.NumberFormatSymbols_vai;


/**
 * Number formatting symbols for locale vai_Vaii.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vai_Vaii = goog.i18n.NumberFormatSymbols_vai;


/**
 * Number formatting symbols for locale vai_Vaii_LR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vai_Vaii_LR = goog.i18n.NumberFormatSymbols_vai;


/**
 * Number formatting symbols for locale vi_VN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vi_VN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'VND'
};


/**
 * Number formatting symbols for locale vun.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vun = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TZS'
};


/**
 * Number formatting symbols for locale vun_TZ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_vun_TZ = goog.i18n.NumberFormatSymbols_vun;


/**
 * Number formatting symbols for locale wae.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_wae = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '’',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'CHF'
};


/**
 * Number formatting symbols for locale wae_CH.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_wae_CH = goog.i18n.NumberFormatSymbols_wae;


/**
 * Number formatting symbols for locale wo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_wo = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale wo_SN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_wo_SN = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale xh.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_xh = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'ZAR'
};


/**
 * Number formatting symbols for locale xh_ZA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_xh_ZA = goog.i18n.NumberFormatSymbols_xh;


/**
 * Number formatting symbols for locale xog.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_xog = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale xog_UG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_xog_UG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'UGX'
};


/**
 * Number formatting symbols for locale yav.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yav = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0.00 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale yav_CM.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yav_CM = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '#,##0 ¤',
  DEF_CURRENCY_CODE: 'XAF'
};


/**
 * Number formatting symbols for locale yi.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yi = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'EUR'
};


/**
 * Number formatting symbols for locale yi_001.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yi_001 = goog.i18n.NumberFormatSymbols_yi;


/**
 * Number formatting symbols for locale yo.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yo = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'NGN'
};


/**
 * Number formatting symbols for locale yo_BJ.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yo_BJ = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0',
  DEF_CURRENCY_CODE: 'XOF'
};


/**
 * Number formatting symbols for locale yo_NG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yo_NG = goog.i18n.NumberFormatSymbols_yo;


/**
 * Number formatting symbols for locale yrl.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yrl = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'BRL'
};


/**
 * Number formatting symbols for locale yrl_BR.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yrl_BR = goog.i18n.NumberFormatSymbols_yrl;


/**
 * Number formatting symbols for locale yrl_CO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yrl_CO = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'COP'
};


/**
 * Number formatting symbols for locale yrl_VE.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yrl_VE = {
  DECIMAL_SEP: ',',
  GROUP_SEP: '.',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤ #,##0.00',
  DEF_CURRENCY_CODE: 'VES'
};


/**
 * Number formatting symbols for locale yue.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yue = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非數值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'HKD'
};


/**
 * Number formatting symbols for locale yue_Hans.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yue_Hans = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非数值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'CNY'
};


/**
 * Number formatting symbols for locale yue_Hans_CN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yue_Hans_CN = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非数值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'CNY'
};


/**
 * Number formatting symbols for locale yue_Hant.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yue_Hant = goog.i18n.NumberFormatSymbols_yue;


/**
 * Number formatting symbols for locale yue_Hant_HK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_yue_Hant_HK = goog.i18n.NumberFormatSymbols_yue;


/**
 * Number formatting symbols for locale zgh.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zgh = {
  DECIMAL_SEP: ',',
  GROUP_SEP: ' ',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0 %',
  CURRENCY_PATTERN: '#,##0.00¤',
  DEF_CURRENCY_CODE: 'MAD'
};


/**
 * Number formatting symbols for locale zgh_MA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zgh_MA = goog.i18n.NumberFormatSymbols_zgh;


/**
 * Number formatting symbols for locale zh_Hans.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hans = goog.i18n.NumberFormatSymbols_zh;


/**
 * Number formatting symbols for locale zh_Hans_CN.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hans_CN = goog.i18n.NumberFormatSymbols_zh;


/**
 * Number formatting symbols for locale zh_Hans_HK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hans_HK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'HKD'
};


/**
 * Number formatting symbols for locale zh_Hans_MO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hans_MO = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'MOP'
};


/**
 * Number formatting symbols for locale zh_Hans_SG.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hans_SG = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: 'NaN',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'SGD'
};


/**
 * Number formatting symbols for locale zh_Hant.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hant = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非數值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TWD'
};


/**
 * Number formatting symbols for locale zh_Hant_HK.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hant_HK = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非數值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'HKD'
};


/**
 * Number formatting symbols for locale zh_Hant_MO.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hant_MO = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非數值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'MOP'
};


/**
 * Number formatting symbols for locale zh_Hant_TW.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zh_Hant_TW = {
  DECIMAL_SEP: '.',
  GROUP_SEP: ',',
  PERCENT: '%',
  ZERO_DIGIT: '0',
  PLUS_SIGN: '+',
  MINUS_SIGN: '-',
  EXP_SYMBOL: 'E',
  PERMILL: '‰',
  INFINITY: '∞',
  NAN: '非數值',
  DECIMAL_PATTERN: '#,##0.###',
  SCIENTIFIC_PATTERN: '#E0',
  PERCENT_PATTERN: '#,##0%',
  CURRENCY_PATTERN: '¤#,##0.00',
  DEF_CURRENCY_CODE: 'TWD'
};


/**
 * Number formatting symbols for locale zu_ZA.
 * @const {!goog.i18n.NumberFormatSymbolsType.Type}
 */
goog.i18n.NumberFormatSymbols_zu_ZA = goog.i18n.NumberFormatSymbols_zu;


/**
 * Selected number formatting symbols by locale.
 */
switch (goog.LOCALE) {
  case 'af_NA':
  case 'af-NA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_af_NA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_af_NA;
    break;
  case 'af_ZA':
  case 'af-ZA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_af_ZA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_af_ZA;
    break;
  case 'agq':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_agq;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_agq;
    break;
  case 'agq_CM':
  case 'agq-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_agq_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_agq_CM;
    break;
  case 'ak':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ak;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ak;
    break;
  case 'ak_GH':
  case 'ak-GH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ak_GH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ak_GH;
    break;
  case 'am_ET':
  case 'am-ET':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_am_ET;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_am_ET;
    break;
  case 'ar_001':
  case 'ar-001':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_001;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_001;
    break;
  case 'ar_AE':
  case 'ar-AE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_AE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_AE;
    break;
  case 'ar_BH':
  case 'ar-BH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_BH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_BH_u_nu_latn;
    break;
  case 'ar_DJ':
  case 'ar-DJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_DJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_DJ_u_nu_latn;
    break;
  case 'ar_EH':
  case 'ar-EH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_EH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_EH;
    break;
  case 'ar_ER':
  case 'ar-ER':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_ER;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_ER_u_nu_latn;
    break;
  case 'ar_IL':
  case 'ar-IL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_IL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_IL_u_nu_latn;
    break;
  case 'ar_IQ':
  case 'ar-IQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_IQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_IQ_u_nu_latn;
    break;
  case 'ar_JO':
  case 'ar-JO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_JO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_JO_u_nu_latn;
    break;
  case 'ar_KM':
  case 'ar-KM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_KM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_KM_u_nu_latn;
    break;
  case 'ar_KW':
  case 'ar-KW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_KW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_KW_u_nu_latn;
    break;
  case 'ar_LB':
  case 'ar-LB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_LB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_LB_u_nu_latn;
    break;
  case 'ar_LY':
  case 'ar-LY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_LY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_LY;
    break;
  case 'ar_MA':
  case 'ar-MA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_MA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_MA;
    break;
  case 'ar_MR':
  case 'ar-MR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_MR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_MR_u_nu_latn;
    break;
  case 'ar_OM':
  case 'ar-OM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_OM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_OM_u_nu_latn;
    break;
  case 'ar_PS':
  case 'ar-PS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_PS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_PS_u_nu_latn;
    break;
  case 'ar_QA':
  case 'ar-QA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_QA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_QA_u_nu_latn;
    break;
  case 'ar_SA':
  case 'ar-SA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_SA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_SA_u_nu_latn;
    break;
  case 'ar_SD':
  case 'ar-SD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_SD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_SD_u_nu_latn;
    break;
  case 'ar_SO':
  case 'ar-SO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_SO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_SO_u_nu_latn;
    break;
  case 'ar_SS':
  case 'ar-SS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_SS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_SS_u_nu_latn;
    break;
  case 'ar_SY':
  case 'ar-SY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_SY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_SY_u_nu_latn;
    break;
  case 'ar_TD':
  case 'ar-TD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_TD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_TD_u_nu_latn;
    break;
  case 'ar_TN':
  case 'ar-TN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_TN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_TN;
    break;
  case 'ar_XB':
  case 'ar-XB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_XB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_XB;
    break;
  case 'ar_YE':
  case 'ar-YE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ar_YE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ar_YE_u_nu_latn;
    break;
  case 'as':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_as;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_as_u_nu_latn;
    break;
  case 'as_IN':
  case 'as-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_as_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_as_IN_u_nu_latn;
    break;
  case 'asa':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_asa;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_asa;
    break;
  case 'asa_TZ':
  case 'asa-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_asa_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_asa_TZ;
    break;
  case 'ast':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ast;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ast;
    break;
  case 'ast_ES':
  case 'ast-ES':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ast_ES;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ast_ES;
    break;
  case 'az_Cyrl':
  case 'az-Cyrl':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_az_Cyrl;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_az_Cyrl;
    break;
  case 'az_Cyrl_AZ':
  case 'az-Cyrl-AZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_az_Cyrl_AZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_az_Cyrl_AZ;
    break;
  case 'az_Latn':
  case 'az-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_az_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_az_Latn;
    break;
  case 'az_Latn_AZ':
  case 'az-Latn-AZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_az_Latn_AZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_az_Latn_AZ;
    break;
  case 'bas':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bas;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bas;
    break;
  case 'bas_CM':
  case 'bas-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bas_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bas_CM;
    break;
  case 'be_BY':
  case 'be-BY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_be_BY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_be_BY;
    break;
  case 'bem':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bem;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bem;
    break;
  case 'bem_ZM':
  case 'bem-ZM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bem_ZM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bem_ZM;
    break;
  case 'bez':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bez;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bez;
    break;
  case 'bez_TZ':
  case 'bez-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bez_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bez_TZ;
    break;
  case 'bg_BG':
  case 'bg-BG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bg_BG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bg_BG;
    break;
  case 'bgc':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bgc;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bgc_u_nu_latn;
    break;
  case 'bgc_IN':
  case 'bgc-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bgc_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bgc_IN_u_nu_latn;
    break;
  case 'bho':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bho;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bho_u_nu_latn;
    break;
  case 'bho_IN':
  case 'bho-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bho_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bho_IN_u_nu_latn;
    break;
  case 'bm':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bm;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bm;
    break;
  case 'bm_ML':
  case 'bm-ML':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bm_ML;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bm_ML;
    break;
  case 'bn_BD':
  case 'bn-BD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bn_BD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bn_BD_u_nu_latn;
    break;
  case 'bn_IN':
  case 'bn-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bn_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bn_IN_u_nu_latn;
    break;
  case 'bo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bo;
    break;
  case 'bo_CN':
  case 'bo-CN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bo_CN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bo_CN;
    break;
  case 'bo_IN':
  case 'bo-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bo_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bo_IN;
    break;
  case 'br_FR':
  case 'br-FR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_br_FR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_br_FR;
    break;
  case 'brx':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_brx;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_brx;
    break;
  case 'brx_IN':
  case 'brx-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_brx_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_brx_IN;
    break;
  case 'bs_Cyrl':
  case 'bs-Cyrl':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bs_Cyrl;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bs_Cyrl;
    break;
  case 'bs_Cyrl_BA':
  case 'bs-Cyrl-BA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bs_Cyrl_BA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bs_Cyrl_BA;
    break;
  case 'bs_Latn':
  case 'bs-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bs_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bs_Latn;
    break;
  case 'bs_Latn_BA':
  case 'bs-Latn-BA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_bs_Latn_BA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_bs_Latn_BA;
    break;
  case 'ca_AD':
  case 'ca-AD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ca_AD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ca_AD;
    break;
  case 'ca_ES':
  case 'ca-ES':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ca_ES;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ca_ES;
    break;
  case 'ca_FR':
  case 'ca-FR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ca_FR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ca_FR;
    break;
  case 'ca_IT':
  case 'ca-IT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ca_IT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ca_IT;
    break;
  case 'ccp':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ccp;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ccp_u_nu_latn;
    break;
  case 'ccp_BD':
  case 'ccp-BD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ccp_BD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ccp_BD_u_nu_latn;
    break;
  case 'ccp_IN':
  case 'ccp-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ccp_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ccp_IN_u_nu_latn;
    break;
  case 'ce':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ce;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ce;
    break;
  case 'ce_RU':
  case 'ce-RU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ce_RU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ce_RU;
    break;
  case 'ceb':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ceb;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ceb;
    break;
  case 'ceb_PH':
  case 'ceb-PH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ceb_PH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ceb_PH;
    break;
  case 'cgg':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_cgg;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_cgg;
    break;
  case 'cgg_UG':
  case 'cgg-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_cgg_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_cgg_UG;
    break;
  case 'chr_US':
  case 'chr-US':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_chr_US;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_chr_US;
    break;
  case 'ckb':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ckb;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_u_nu_latn;
    break;
  case 'ckb_Arab':
  case 'ckb-Arab':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ckb_Arab;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_Arab_u_nu_latn;
    break;
  case 'ckb_Arab_IQ':
  case 'ckb-Arab-IQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ckb_Arab_IQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_Arab_IQ_u_nu_latn;
    break;
  case 'ckb_Arab_IR':
  case 'ckb-Arab-IR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ckb_Arab_IR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_Arab_IR_u_nu_latn;
    break;
  case 'ckb_IQ':
  case 'ckb-IQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ckb_IQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_IQ_u_nu_latn;
    break;
  case 'ckb_IR':
  case 'ckb-IR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ckb_IR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ckb_IR_u_nu_latn;
    break;
  case 'cs_CZ':
  case 'cs-CZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_cs_CZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_cs_CZ;
    break;
  case 'cv':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_cv;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_cv;
    break;
  case 'cv_RU':
  case 'cv-RU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_cv_RU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_cv_RU;
    break;
  case 'cy_GB':
  case 'cy-GB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_cy_GB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_cy_GB;
    break;
  case 'da_DK':
  case 'da-DK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_da_DK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_da_DK;
    break;
  case 'da_GL':
  case 'da-GL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_da_GL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_da_GL;
    break;
  case 'dav':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dav;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dav;
    break;
  case 'dav_KE':
  case 'dav-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dav_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dav_KE;
    break;
  case 'de_BE':
  case 'de-BE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_de_BE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_de_BE;
    break;
  case 'de_DE':
  case 'de-DE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_de_DE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_de_DE;
    break;
  case 'de_IT':
  case 'de-IT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_de_IT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_de_IT;
    break;
  case 'de_LI':
  case 'de-LI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_de_LI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_de_LI;
    break;
  case 'de_LU':
  case 'de-LU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_de_LU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_de_LU;
    break;
  case 'dje':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dje;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dje;
    break;
  case 'dje_NE':
  case 'dje-NE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dje_NE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dje_NE;
    break;
  case 'doi':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_doi;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_doi;
    break;
  case 'doi_IN':
  case 'doi-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_doi_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_doi_IN;
    break;
  case 'dsb':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dsb;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dsb;
    break;
  case 'dsb_DE':
  case 'dsb-DE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dsb_DE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dsb_DE;
    break;
  case 'dua':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dua;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dua;
    break;
  case 'dua_CM':
  case 'dua-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dua_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dua_CM;
    break;
  case 'dyo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dyo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dyo;
    break;
  case 'dyo_SN':
  case 'dyo-SN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dyo_SN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dyo_SN;
    break;
  case 'dz':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dz;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dz_u_nu_latn;
    break;
  case 'dz_BT':
  case 'dz-BT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_dz_BT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_dz_BT_u_nu_latn;
    break;
  case 'ebu':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ebu;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ebu;
    break;
  case 'ebu_KE':
  case 'ebu-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ebu_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ebu_KE;
    break;
  case 'ee':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ee;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ee;
    break;
  case 'ee_GH':
  case 'ee-GH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ee_GH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ee_GH;
    break;
  case 'ee_TG':
  case 'ee-TG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ee_TG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ee_TG;
    break;
  case 'el_CY':
  case 'el-CY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_el_CY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_el_CY;
    break;
  case 'el_GR':
  case 'el-GR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_el_GR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_el_GR;
    break;
  case 'en_001':
  case 'en-001':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_001;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_001;
    break;
  case 'en_150':
  case 'en-150':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_150;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_150;
    break;
  case 'en_AE':
  case 'en-AE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_AE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_AE;
    break;
  case 'en_AG':
  case 'en-AG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_AG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_AG;
    break;
  case 'en_AI':
  case 'en-AI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_AI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_AI;
    break;
  case 'en_AS':
  case 'en-AS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_AS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_AS;
    break;
  case 'en_AT':
  case 'en-AT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_AT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_AT;
    break;
  case 'en_BB':
  case 'en-BB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BB;
    break;
  case 'en_BE':
  case 'en-BE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BE;
    break;
  case 'en_BI':
  case 'en-BI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BI;
    break;
  case 'en_BM':
  case 'en-BM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BM;
    break;
  case 'en_BS':
  case 'en-BS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BS;
    break;
  case 'en_BW':
  case 'en-BW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BW;
    break;
  case 'en_BZ':
  case 'en-BZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_BZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_BZ;
    break;
  case 'en_CC':
  case 'en-CC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_CC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_CC;
    break;
  case 'en_CH':
  case 'en-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_CH;
    break;
  case 'en_CK':
  case 'en-CK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_CK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_CK;
    break;
  case 'en_CM':
  case 'en-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_CM;
    break;
  case 'en_CX':
  case 'en-CX':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_CX;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_CX;
    break;
  case 'en_CY':
  case 'en-CY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_CY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_CY;
    break;
  case 'en_DE':
  case 'en-DE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_DE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_DE;
    break;
  case 'en_DG':
  case 'en-DG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_DG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_DG;
    break;
  case 'en_DK':
  case 'en-DK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_DK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_DK;
    break;
  case 'en_DM':
  case 'en-DM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_DM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_DM;
    break;
  case 'en_ER':
  case 'en-ER':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_ER;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_ER;
    break;
  case 'en_FI':
  case 'en-FI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_FI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_FI;
    break;
  case 'en_FJ':
  case 'en-FJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_FJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_FJ;
    break;
  case 'en_FK':
  case 'en-FK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_FK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_FK;
    break;
  case 'en_FM':
  case 'en-FM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_FM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_FM;
    break;
  case 'en_GD':
  case 'en-GD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GD;
    break;
  case 'en_GG':
  case 'en-GG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GG;
    break;
  case 'en_GH':
  case 'en-GH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GH;
    break;
  case 'en_GI':
  case 'en-GI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GI;
    break;
  case 'en_GM':
  case 'en-GM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GM;
    break;
  case 'en_GU':
  case 'en-GU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GU;
    break;
  case 'en_GY':
  case 'en-GY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_GY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_GY;
    break;
  case 'en_HK':
  case 'en-HK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_HK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_HK;
    break;
  case 'en_IL':
  case 'en-IL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_IL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_IL;
    break;
  case 'en_IM':
  case 'en-IM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_IM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_IM;
    break;
  case 'en_IO':
  case 'en-IO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_IO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_IO;
    break;
  case 'en_JE':
  case 'en-JE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_JE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_JE;
    break;
  case 'en_JM':
  case 'en-JM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_JM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_JM;
    break;
  case 'en_KE':
  case 'en-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_KE;
    break;
  case 'en_KI':
  case 'en-KI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_KI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_KI;
    break;
  case 'en_KN':
  case 'en-KN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_KN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_KN;
    break;
  case 'en_KY':
  case 'en-KY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_KY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_KY;
    break;
  case 'en_LC':
  case 'en-LC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_LC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_LC;
    break;
  case 'en_LR':
  case 'en-LR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_LR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_LR;
    break;
  case 'en_LS':
  case 'en-LS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_LS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_LS;
    break;
  case 'en_MG':
  case 'en-MG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MG;
    break;
  case 'en_MH':
  case 'en-MH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MH;
    break;
  case 'en_MO':
  case 'en-MO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MO;
    break;
  case 'en_MP':
  case 'en-MP':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MP;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MP;
    break;
  case 'en_MS':
  case 'en-MS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MS;
    break;
  case 'en_MT':
  case 'en-MT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MT;
    break;
  case 'en_MU':
  case 'en-MU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MU;
    break;
  case 'en_MV':
  case 'en-MV':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MV;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MV;
    break;
  case 'en_MW':
  case 'en-MW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MW;
    break;
  case 'en_MY':
  case 'en-MY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_MY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_MY;
    break;
  case 'en_NA':
  case 'en-NA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NA;
    break;
  case 'en_NF':
  case 'en-NF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NF;
    break;
  case 'en_NG':
  case 'en-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NG;
    break;
  case 'en_NL':
  case 'en-NL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NL;
    break;
  case 'en_NR':
  case 'en-NR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NR;
    break;
  case 'en_NU':
  case 'en-NU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NU;
    break;
  case 'en_NZ':
  case 'en-NZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_NZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_NZ;
    break;
  case 'en_PG':
  case 'en-PG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_PG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_PG;
    break;
  case 'en_PH':
  case 'en-PH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_PH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_PH;
    break;
  case 'en_PK':
  case 'en-PK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_PK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_PK;
    break;
  case 'en_PN':
  case 'en-PN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_PN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_PN;
    break;
  case 'en_PR':
  case 'en-PR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_PR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_PR;
    break;
  case 'en_PW':
  case 'en-PW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_PW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_PW;
    break;
  case 'en_RW':
  case 'en-RW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_RW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_RW;
    break;
  case 'en_SB':
  case 'en-SB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SB;
    break;
  case 'en_SC':
  case 'en-SC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SC;
    break;
  case 'en_SD':
  case 'en-SD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SD;
    break;
  case 'en_SE':
  case 'en-SE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SE;
    break;
  case 'en_SH':
  case 'en-SH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SH;
    break;
  case 'en_SI':
  case 'en-SI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SI;
    break;
  case 'en_SL':
  case 'en-SL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SL;
    break;
  case 'en_SS':
  case 'en-SS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SS;
    break;
  case 'en_SX':
  case 'en-SX':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SX;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SX;
    break;
  case 'en_SZ':
  case 'en-SZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_SZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_SZ;
    break;
  case 'en_TC':
  case 'en-TC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_TC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_TC;
    break;
  case 'en_TK':
  case 'en-TK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_TK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_TK;
    break;
  case 'en_TO':
  case 'en-TO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_TO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_TO;
    break;
  case 'en_TT':
  case 'en-TT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_TT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_TT;
    break;
  case 'en_TV':
  case 'en-TV':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_TV;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_TV;
    break;
  case 'en_TZ':
  case 'en-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_TZ;
    break;
  case 'en_UG':
  case 'en-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_UG;
    break;
  case 'en_UM':
  case 'en-UM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_UM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_UM;
    break;
  case 'en_US_POSIX':
  case 'en-US-POSIX':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_US_POSIX;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_US_POSIX;
    break;
  case 'en_VC':
  case 'en-VC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_VC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_VC;
    break;
  case 'en_VG':
  case 'en-VG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_VG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_VG;
    break;
  case 'en_VI':
  case 'en-VI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_VI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_VI;
    break;
  case 'en_VU':
  case 'en-VU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_VU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_VU;
    break;
  case 'en_WS':
  case 'en-WS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_WS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_WS;
    break;
  case 'en_XA':
  case 'en-XA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_XA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_XA;
    break;
  case 'en_ZM':
  case 'en-ZM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_ZM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_ZM;
    break;
  case 'en_ZW':
  case 'en-ZW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_en_ZW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_en_ZW;
    break;
  case 'eo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_eo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_eo;
    break;
  case 'eo_001':
  case 'eo-001':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_eo_001;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_eo_001;
    break;
  case 'es_AR':
  case 'es-AR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_AR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_AR;
    break;
  case 'es_BO':
  case 'es-BO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_BO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_BO;
    break;
  case 'es_BR':
  case 'es-BR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_BR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_BR;
    break;
  case 'es_BZ':
  case 'es-BZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_BZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_BZ;
    break;
  case 'es_CL':
  case 'es-CL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_CL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_CL;
    break;
  case 'es_CO':
  case 'es-CO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_CO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_CO;
    break;
  case 'es_CR':
  case 'es-CR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_CR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_CR;
    break;
  case 'es_CU':
  case 'es-CU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_CU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_CU;
    break;
  case 'es_DO':
  case 'es-DO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_DO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_DO;
    break;
  case 'es_EA':
  case 'es-EA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_EA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_EA;
    break;
  case 'es_EC':
  case 'es-EC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_EC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_EC;
    break;
  case 'es_GQ':
  case 'es-GQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_GQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_GQ;
    break;
  case 'es_GT':
  case 'es-GT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_GT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_GT;
    break;
  case 'es_HN':
  case 'es-HN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_HN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_HN;
    break;
  case 'es_IC':
  case 'es-IC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_IC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_IC;
    break;
  case 'es_NI':
  case 'es-NI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_NI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_NI;
    break;
  case 'es_PA':
  case 'es-PA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_PA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_PA;
    break;
  case 'es_PE':
  case 'es-PE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_PE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_PE;
    break;
  case 'es_PH':
  case 'es-PH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_PH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_PH;
    break;
  case 'es_PR':
  case 'es-PR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_PR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_PR;
    break;
  case 'es_PY':
  case 'es-PY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_PY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_PY;
    break;
  case 'es_SV':
  case 'es-SV':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_SV;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_SV;
    break;
  case 'es_UY':
  case 'es-UY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_UY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_UY;
    break;
  case 'es_VE':
  case 'es-VE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_es_VE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_es_VE;
    break;
  case 'et_EE':
  case 'et-EE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_et_EE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_et_EE;
    break;
  case 'eu_ES':
  case 'eu-ES':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_eu_ES;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_eu_ES;
    break;
  case 'ewo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ewo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ewo;
    break;
  case 'ewo_CM':
  case 'ewo-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ewo_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ewo_CM;
    break;
  case 'fa_AF':
  case 'fa-AF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fa_AF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fa_AF_u_nu_latn;
    break;
  case 'fa_IR':
  case 'fa-IR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fa_IR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fa_IR_u_nu_latn;
    break;
  case 'ff':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff;
    break;
  case 'ff_Adlm':
  case 'ff-Adlm':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_u_nu_latn;
    break;
  case 'ff_Adlm_BF':
  case 'ff-Adlm-BF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_BF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_BF_u_nu_latn;
    break;
  case 'ff_Adlm_CM':
  case 'ff-Adlm-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_CM_u_nu_latn;
    break;
  case 'ff_Adlm_GH':
  case 'ff-Adlm-GH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_GH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_GH_u_nu_latn;
    break;
  case 'ff_Adlm_GM':
  case 'ff-Adlm-GM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_GM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_GM_u_nu_latn;
    break;
  case 'ff_Adlm_GN':
  case 'ff-Adlm-GN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_GN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_GN_u_nu_latn;
    break;
  case 'ff_Adlm_GW':
  case 'ff-Adlm-GW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_GW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_GW_u_nu_latn;
    break;
  case 'ff_Adlm_LR':
  case 'ff-Adlm-LR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_LR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_LR_u_nu_latn;
    break;
  case 'ff_Adlm_MR':
  case 'ff-Adlm-MR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_MR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_MR_u_nu_latn;
    break;
  case 'ff_Adlm_NE':
  case 'ff-Adlm-NE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_NE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_NE_u_nu_latn;
    break;
  case 'ff_Adlm_NG':
  case 'ff-Adlm-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_NG_u_nu_latn;
    break;
  case 'ff_Adlm_SL':
  case 'ff-Adlm-SL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_SL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_SL_u_nu_latn;
    break;
  case 'ff_Adlm_SN':
  case 'ff-Adlm-SN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Adlm_SN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Adlm_SN_u_nu_latn;
    break;
  case 'ff_Latn':
  case 'ff-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn;
    break;
  case 'ff_Latn_BF':
  case 'ff-Latn-BF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_BF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_BF;
    break;
  case 'ff_Latn_CM':
  case 'ff-Latn-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_CM;
    break;
  case 'ff_Latn_GH':
  case 'ff-Latn-GH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_GH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_GH;
    break;
  case 'ff_Latn_GM':
  case 'ff-Latn-GM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_GM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_GM;
    break;
  case 'ff_Latn_GN':
  case 'ff-Latn-GN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_GN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_GN;
    break;
  case 'ff_Latn_GW':
  case 'ff-Latn-GW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_GW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_GW;
    break;
  case 'ff_Latn_LR':
  case 'ff-Latn-LR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_LR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_LR;
    break;
  case 'ff_Latn_MR':
  case 'ff-Latn-MR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_MR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_MR;
    break;
  case 'ff_Latn_NE':
  case 'ff-Latn-NE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_NE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_NE;
    break;
  case 'ff_Latn_NG':
  case 'ff-Latn-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_NG;
    break;
  case 'ff_Latn_SL':
  case 'ff-Latn-SL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_SL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_SL;
    break;
  case 'ff_Latn_SN':
  case 'ff-Latn-SN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ff_Latn_SN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ff_Latn_SN;
    break;
  case 'fi_FI':
  case 'fi-FI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fi_FI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fi_FI;
    break;
  case 'fil_PH':
  case 'fil-PH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fil_PH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fil_PH;
    break;
  case 'fo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fo;
    break;
  case 'fo_DK':
  case 'fo-DK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fo_DK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fo_DK;
    break;
  case 'fo_FO':
  case 'fo-FO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fo_FO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fo_FO;
    break;
  case 'fr_BE':
  case 'fr-BE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_BE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_BE;
    break;
  case 'fr_BF':
  case 'fr-BF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_BF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_BF;
    break;
  case 'fr_BI':
  case 'fr-BI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_BI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_BI;
    break;
  case 'fr_BJ':
  case 'fr-BJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_BJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_BJ;
    break;
  case 'fr_BL':
  case 'fr-BL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_BL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_BL;
    break;
  case 'fr_CD':
  case 'fr-CD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_CD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_CD;
    break;
  case 'fr_CF':
  case 'fr-CF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_CF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_CF;
    break;
  case 'fr_CG':
  case 'fr-CG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_CG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_CG;
    break;
  case 'fr_CH':
  case 'fr-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_CH;
    break;
  case 'fr_CI':
  case 'fr-CI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_CI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_CI;
    break;
  case 'fr_CM':
  case 'fr-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_CM;
    break;
  case 'fr_DJ':
  case 'fr-DJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_DJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_DJ;
    break;
  case 'fr_DZ':
  case 'fr-DZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_DZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_DZ;
    break;
  case 'fr_FR':
  case 'fr-FR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_FR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_FR;
    break;
  case 'fr_GA':
  case 'fr-GA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_GA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_GA;
    break;
  case 'fr_GF':
  case 'fr-GF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_GF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_GF;
    break;
  case 'fr_GN':
  case 'fr-GN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_GN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_GN;
    break;
  case 'fr_GP':
  case 'fr-GP':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_GP;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_GP;
    break;
  case 'fr_GQ':
  case 'fr-GQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_GQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_GQ;
    break;
  case 'fr_HT':
  case 'fr-HT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_HT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_HT;
    break;
  case 'fr_KM':
  case 'fr-KM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_KM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_KM;
    break;
  case 'fr_LU':
  case 'fr-LU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_LU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_LU;
    break;
  case 'fr_MA':
  case 'fr-MA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MA;
    break;
  case 'fr_MC':
  case 'fr-MC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MC;
    break;
  case 'fr_MF':
  case 'fr-MF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MF;
    break;
  case 'fr_MG':
  case 'fr-MG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MG;
    break;
  case 'fr_ML':
  case 'fr-ML':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_ML;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_ML;
    break;
  case 'fr_MQ':
  case 'fr-MQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MQ;
    break;
  case 'fr_MR':
  case 'fr-MR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MR;
    break;
  case 'fr_MU':
  case 'fr-MU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_MU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_MU;
    break;
  case 'fr_NC':
  case 'fr-NC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_NC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_NC;
    break;
  case 'fr_NE':
  case 'fr-NE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_NE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_NE;
    break;
  case 'fr_PF':
  case 'fr-PF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_PF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_PF;
    break;
  case 'fr_PM':
  case 'fr-PM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_PM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_PM;
    break;
  case 'fr_RE':
  case 'fr-RE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_RE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_RE;
    break;
  case 'fr_RW':
  case 'fr-RW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_RW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_RW;
    break;
  case 'fr_SC':
  case 'fr-SC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_SC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_SC;
    break;
  case 'fr_SN':
  case 'fr-SN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_SN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_SN;
    break;
  case 'fr_SY':
  case 'fr-SY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_SY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_SY;
    break;
  case 'fr_TD':
  case 'fr-TD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_TD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_TD;
    break;
  case 'fr_TG':
  case 'fr-TG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_TG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_TG;
    break;
  case 'fr_TN':
  case 'fr-TN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_TN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_TN;
    break;
  case 'fr_VU':
  case 'fr-VU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_VU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_VU;
    break;
  case 'fr_WF':
  case 'fr-WF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_WF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_WF;
    break;
  case 'fr_YT':
  case 'fr-YT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fr_YT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fr_YT;
    break;
  case 'fur':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fur;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fur;
    break;
  case 'fur_IT':
  case 'fur-IT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fur_IT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fur_IT;
    break;
  case 'fy':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fy;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fy;
    break;
  case 'fy_NL':
  case 'fy-NL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_fy_NL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_fy_NL;
    break;
  case 'ga_GB':
  case 'ga-GB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ga_GB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ga_GB;
    break;
  case 'ga_IE':
  case 'ga-IE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ga_IE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ga_IE;
    break;
  case 'gd':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gd;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gd;
    break;
  case 'gd_GB':
  case 'gd-GB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gd_GB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gd_GB;
    break;
  case 'gl_ES':
  case 'gl-ES':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gl_ES;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gl_ES;
    break;
  case 'gsw_CH':
  case 'gsw-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gsw_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gsw_CH;
    break;
  case 'gsw_FR':
  case 'gsw-FR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gsw_FR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gsw_FR;
    break;
  case 'gsw_LI':
  case 'gsw-LI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gsw_LI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gsw_LI;
    break;
  case 'gu_IN':
  case 'gu-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gu_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gu_IN;
    break;
  case 'guz':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_guz;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_guz;
    break;
  case 'guz_KE':
  case 'guz-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_guz_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_guz_KE;
    break;
  case 'gv':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gv;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gv;
    break;
  case 'gv_IM':
  case 'gv-IM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_gv_IM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_gv_IM;
    break;
  case 'ha':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ha;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ha;
    break;
  case 'ha_GH':
  case 'ha-GH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ha_GH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ha_GH;
    break;
  case 'ha_NE':
  case 'ha-NE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ha_NE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ha_NE;
    break;
  case 'ha_NG':
  case 'ha-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ha_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ha_NG;
    break;
  case 'haw_US':
  case 'haw-US':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_haw_US;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_haw_US;
    break;
  case 'he_IL':
  case 'he-IL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_he_IL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_he_IL;
    break;
  case 'hi_IN':
  case 'hi-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hi_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hi_IN;
    break;
  case 'hi_Latn':
  case 'hi-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hi_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hi_Latn;
    break;
  case 'hi_Latn_IN':
  case 'hi-Latn-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hi_Latn_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hi_Latn_IN;
    break;
  case 'hr_BA':
  case 'hr-BA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hr_BA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hr_BA;
    break;
  case 'hr_HR':
  case 'hr-HR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hr_HR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hr_HR;
    break;
  case 'hsb':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hsb;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hsb;
    break;
  case 'hsb_DE':
  case 'hsb-DE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hsb_DE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hsb_DE;
    break;
  case 'hu_HU':
  case 'hu-HU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hu_HU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hu_HU;
    break;
  case 'hy_AM':
  case 'hy-AM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_hy_AM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_hy_AM;
    break;
  case 'ia':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ia;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ia;
    break;
  case 'ia_001':
  case 'ia-001':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ia_001;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ia_001;
    break;
  case 'id_ID':
  case 'id-ID':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_id_ID;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_id_ID;
    break;
  case 'ig':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ig;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ig;
    break;
  case 'ig_NG':
  case 'ig-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ig_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ig_NG;
    break;
  case 'ii':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ii;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ii;
    break;
  case 'ii_CN':
  case 'ii-CN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ii_CN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ii_CN;
    break;
  case 'is_IS':
  case 'is-IS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_is_IS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_is_IS;
    break;
  case 'it_CH':
  case 'it-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_it_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_it_CH;
    break;
  case 'it_IT':
  case 'it-IT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_it_IT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_it_IT;
    break;
  case 'it_SM':
  case 'it-SM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_it_SM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_it_SM;
    break;
  case 'it_VA':
  case 'it-VA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_it_VA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_it_VA;
    break;
  case 'ja_JP':
  case 'ja-JP':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ja_JP;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ja_JP;
    break;
  case 'jgo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_jgo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_jgo;
    break;
  case 'jgo_CM':
  case 'jgo-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_jgo_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_jgo_CM;
    break;
  case 'jmc':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_jmc;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_jmc;
    break;
  case 'jmc_TZ':
  case 'jmc-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_jmc_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_jmc_TZ;
    break;
  case 'jv':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_jv;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_jv;
    break;
  case 'jv_ID':
  case 'jv-ID':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_jv_ID;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_jv_ID;
    break;
  case 'ka_GE':
  case 'ka-GE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ka_GE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ka_GE;
    break;
  case 'kab':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kab;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kab;
    break;
  case 'kab_DZ':
  case 'kab-DZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kab_DZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kab_DZ;
    break;
  case 'kam':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kam;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kam;
    break;
  case 'kam_KE':
  case 'kam-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kam_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kam_KE;
    break;
  case 'kde':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kde;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kde;
    break;
  case 'kde_TZ':
  case 'kde-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kde_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kde_TZ;
    break;
  case 'kea':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kea;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kea;
    break;
  case 'kea_CV':
  case 'kea-CV':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kea_CV;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kea_CV;
    break;
  case 'kgp':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kgp;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kgp;
    break;
  case 'kgp_BR':
  case 'kgp-BR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kgp_BR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kgp_BR;
    break;
  case 'khq':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_khq;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_khq;
    break;
  case 'khq_ML':
  case 'khq-ML':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_khq_ML;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_khq_ML;
    break;
  case 'ki':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ki;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ki;
    break;
  case 'ki_KE':
  case 'ki-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ki_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ki_KE;
    break;
  case 'kk_KZ':
  case 'kk-KZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kk_KZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kk_KZ;
    break;
  case 'kkj':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kkj;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kkj;
    break;
  case 'kkj_CM':
  case 'kkj-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kkj_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kkj_CM;
    break;
  case 'kl':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kl;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kl;
    break;
  case 'kl_GL':
  case 'kl-GL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kl_GL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kl_GL;
    break;
  case 'kln':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kln;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kln;
    break;
  case 'kln_KE':
  case 'kln-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kln_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kln_KE;
    break;
  case 'km_KH':
  case 'km-KH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_km_KH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_km_KH;
    break;
  case 'kn_IN':
  case 'kn-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kn_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kn_IN;
    break;
  case 'ko_KP':
  case 'ko-KP':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ko_KP;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ko_KP;
    break;
  case 'ko_KR':
  case 'ko-KR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ko_KR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ko_KR;
    break;
  case 'kok':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kok;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kok;
    break;
  case 'kok_IN':
  case 'kok-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kok_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kok_IN;
    break;
  case 'ks':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ks;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_u_nu_latn;
    break;
  case 'ks_Arab':
  case 'ks-Arab':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ks_Arab;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_Arab_u_nu_latn;
    break;
  case 'ks_Arab_IN':
  case 'ks-Arab-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ks_Arab_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_Arab_IN_u_nu_latn;
    break;
  case 'ks_Deva':
  case 'ks-Deva':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ks_Deva;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_Deva;
    break;
  case 'ks_Deva_IN':
  case 'ks-Deva-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ks_Deva_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ks_Deva_IN;
    break;
  case 'ksb':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ksb;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ksb;
    break;
  case 'ksb_TZ':
  case 'ksb-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ksb_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ksb_TZ;
    break;
  case 'ksf':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ksf;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ksf;
    break;
  case 'ksf_CM':
  case 'ksf-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ksf_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ksf_CM;
    break;
  case 'ksh':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ksh;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ksh;
    break;
  case 'ksh_DE':
  case 'ksh-DE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ksh_DE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ksh_DE;
    break;
  case 'ku':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ku;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ku;
    break;
  case 'ku_TR':
  case 'ku-TR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ku_TR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ku_TR;
    break;
  case 'kw':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kw;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kw;
    break;
  case 'kw_GB':
  case 'kw-GB':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_kw_GB;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_kw_GB;
    break;
  case 'ky_KG':
  case 'ky-KG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ky_KG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ky_KG;
    break;
  case 'lag':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lag;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lag;
    break;
  case 'lag_TZ':
  case 'lag-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lag_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lag_TZ;
    break;
  case 'lb':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lb;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lb;
    break;
  case 'lb_LU':
  case 'lb-LU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lb_LU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lb_LU;
    break;
  case 'lg':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lg;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lg;
    break;
  case 'lg_UG':
  case 'lg-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lg_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lg_UG;
    break;
  case 'lkt':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lkt;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lkt;
    break;
  case 'lkt_US':
  case 'lkt-US':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lkt_US;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lkt_US;
    break;
  case 'ln_AO':
  case 'ln-AO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ln_AO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ln_AO;
    break;
  case 'ln_CD':
  case 'ln-CD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ln_CD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ln_CD;
    break;
  case 'ln_CF':
  case 'ln-CF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ln_CF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ln_CF;
    break;
  case 'ln_CG':
  case 'ln-CG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ln_CG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ln_CG;
    break;
  case 'lo_LA':
  case 'lo-LA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lo_LA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lo_LA;
    break;
  case 'lrc':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lrc;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lrc_u_nu_latn;
    break;
  case 'lrc_IQ':
  case 'lrc-IQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lrc_IQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lrc_IQ_u_nu_latn;
    break;
  case 'lrc_IR':
  case 'lrc-IR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lrc_IR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lrc_IR_u_nu_latn;
    break;
  case 'lt_LT':
  case 'lt-LT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lt_LT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lt_LT;
    break;
  case 'lu':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lu;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lu;
    break;
  case 'lu_CD':
  case 'lu-CD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lu_CD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lu_CD;
    break;
  case 'luo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_luo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_luo;
    break;
  case 'luo_KE':
  case 'luo-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_luo_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_luo_KE;
    break;
  case 'luy':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_luy;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_luy;
    break;
  case 'luy_KE':
  case 'luy-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_luy_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_luy_KE;
    break;
  case 'lv_LV':
  case 'lv-LV':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_lv_LV;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_lv_LV;
    break;
  case 'mai':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mai;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mai;
    break;
  case 'mai_IN':
  case 'mai-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mai_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mai_IN;
    break;
  case 'mas':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mas;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mas;
    break;
  case 'mas_KE':
  case 'mas-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mas_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mas_KE;
    break;
  case 'mas_TZ':
  case 'mas-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mas_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mas_TZ;
    break;
  case 'mer':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mer;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mer;
    break;
  case 'mer_KE':
  case 'mer-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mer_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mer_KE;
    break;
  case 'mfe':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mfe;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mfe;
    break;
  case 'mfe_MU':
  case 'mfe-MU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mfe_MU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mfe_MU;
    break;
  case 'mg':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mg;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mg;
    break;
  case 'mg_MG':
  case 'mg-MG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mg_MG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mg_MG;
    break;
  case 'mgh':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mgh;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mgh;
    break;
  case 'mgh_MZ':
  case 'mgh-MZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mgh_MZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mgh_MZ;
    break;
  case 'mgo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mgo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mgo;
    break;
  case 'mgo_CM':
  case 'mgo-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mgo_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mgo_CM;
    break;
  case 'mi':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mi;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mi;
    break;
  case 'mi_NZ':
  case 'mi-NZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mi_NZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mi_NZ;
    break;
  case 'mk_MK':
  case 'mk-MK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mk_MK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mk_MK;
    break;
  case 'ml_IN':
  case 'ml-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ml_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ml_IN;
    break;
  case 'mn_MN':
  case 'mn-MN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mn_MN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mn_MN;
    break;
  case 'mni':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mni;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mni_u_nu_latn;
    break;
  case 'mni_Beng':
  case 'mni-Beng':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mni_Beng;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mni_Beng_u_nu_latn;
    break;
  case 'mni_Beng_IN':
  case 'mni-Beng-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mni_Beng_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mni_Beng_IN_u_nu_latn;
    break;
  case 'mr_IN':
  case 'mr-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mr_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mr_IN_u_nu_latn;
    break;
  case 'ms_BN':
  case 'ms-BN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ms_BN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ms_BN;
    break;
  case 'ms_ID':
  case 'ms-ID':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ms_ID;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ms_ID;
    break;
  case 'ms_MY':
  case 'ms-MY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ms_MY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ms_MY;
    break;
  case 'ms_SG':
  case 'ms-SG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ms_SG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ms_SG;
    break;
  case 'mt_MT':
  case 'mt-MT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mt_MT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mt_MT;
    break;
  case 'mua':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mua;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mua;
    break;
  case 'mua_CM':
  case 'mua-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mua_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mua_CM;
    break;
  case 'my_MM':
  case 'my-MM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_my_MM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_my_MM_u_nu_latn;
    break;
  case 'mzn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mzn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mzn_u_nu_latn;
    break;
  case 'mzn_IR':
  case 'mzn-IR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_mzn_IR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_mzn_IR_u_nu_latn;
    break;
  case 'naq':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_naq;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_naq;
    break;
  case 'naq_NA':
  case 'naq-NA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_naq_NA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_naq_NA;
    break;
  case 'nb_NO':
  case 'nb-NO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nb_NO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nb_NO;
    break;
  case 'nb_SJ':
  case 'nb-SJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nb_SJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nb_SJ;
    break;
  case 'nd':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nd;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nd;
    break;
  case 'nd_ZW':
  case 'nd-ZW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nd_ZW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nd_ZW;
    break;
  case 'ne_IN':
  case 'ne-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ne_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ne_IN_u_nu_latn;
    break;
  case 'ne_NP':
  case 'ne-NP':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ne_NP;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ne_NP_u_nu_latn;
    break;
  case 'nl_AW':
  case 'nl-AW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_AW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_AW;
    break;
  case 'nl_BE':
  case 'nl-BE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_BE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_BE;
    break;
  case 'nl_BQ':
  case 'nl-BQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_BQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_BQ;
    break;
  case 'nl_CW':
  case 'nl-CW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_CW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_CW;
    break;
  case 'nl_NL':
  case 'nl-NL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_NL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_NL;
    break;
  case 'nl_SR':
  case 'nl-SR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_SR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_SR;
    break;
  case 'nl_SX':
  case 'nl-SX':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nl_SX;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nl_SX;
    break;
  case 'nmg':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nmg;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nmg;
    break;
  case 'nmg_CM':
  case 'nmg-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nmg_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nmg_CM;
    break;
  case 'nn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nn;
    break;
  case 'nn_NO':
  case 'nn-NO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nn_NO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nn_NO;
    break;
  case 'nnh':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nnh;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nnh;
    break;
  case 'nnh_CM':
  case 'nnh-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nnh_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nnh_CM;
    break;
  case 'nus':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nus;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nus;
    break;
  case 'nus_SS':
  case 'nus-SS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nus_SS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nus_SS;
    break;
  case 'nyn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nyn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nyn;
    break;
  case 'nyn_UG':
  case 'nyn-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_nyn_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_nyn_UG;
    break;
  case 'om':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_om;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_om;
    break;
  case 'om_ET':
  case 'om-ET':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_om_ET;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_om_ET;
    break;
  case 'om_KE':
  case 'om-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_om_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_om_KE;
    break;
  case 'or_IN':
  case 'or-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_or_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_or_IN;
    break;
  case 'os':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_os;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_os;
    break;
  case 'os_GE':
  case 'os-GE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_os_GE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_os_GE;
    break;
  case 'os_RU':
  case 'os-RU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_os_RU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_os_RU;
    break;
  case 'pa_Arab':
  case 'pa-Arab':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pa_Arab;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pa_Arab_u_nu_latn;
    break;
  case 'pa_Arab_PK':
  case 'pa-Arab-PK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pa_Arab_PK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pa_Arab_PK_u_nu_latn;
    break;
  case 'pa_Guru':
  case 'pa-Guru':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pa_Guru;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pa_Guru;
    break;
  case 'pa_Guru_IN':
  case 'pa-Guru-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pa_Guru_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pa_Guru_IN;
    break;
  case 'pcm':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pcm;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pcm;
    break;
  case 'pcm_NG':
  case 'pcm-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pcm_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pcm_NG;
    break;
  case 'pl_PL':
  case 'pl-PL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pl_PL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pl_PL;
    break;
  case 'ps':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ps;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ps_u_nu_latn;
    break;
  case 'ps_AF':
  case 'ps-AF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ps_AF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ps_AF_u_nu_latn;
    break;
  case 'ps_PK':
  case 'ps-PK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ps_PK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ps_PK_u_nu_latn;
    break;
  case 'pt_AO':
  case 'pt-AO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_AO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_AO;
    break;
  case 'pt_CH':
  case 'pt-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_CH;
    break;
  case 'pt_CV':
  case 'pt-CV':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_CV;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_CV;
    break;
  case 'pt_GQ':
  case 'pt-GQ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_GQ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_GQ;
    break;
  case 'pt_GW':
  case 'pt-GW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_GW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_GW;
    break;
  case 'pt_LU':
  case 'pt-LU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_LU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_LU;
    break;
  case 'pt_MO':
  case 'pt-MO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_MO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_MO;
    break;
  case 'pt_MZ':
  case 'pt-MZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_MZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_MZ;
    break;
  case 'pt_ST':
  case 'pt-ST':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_ST;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_ST;
    break;
  case 'pt_TL':
  case 'pt-TL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_pt_TL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_pt_TL;
    break;
  case 'qu':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_qu;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_qu;
    break;
  case 'qu_BO':
  case 'qu-BO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_qu_BO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_qu_BO;
    break;
  case 'qu_EC':
  case 'qu-EC':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_qu_EC;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_qu_EC;
    break;
  case 'qu_PE':
  case 'qu-PE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_qu_PE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_qu_PE;
    break;
  case 'raj':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_raj;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_raj_u_nu_latn;
    break;
  case 'raj_IN':
  case 'raj-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_raj_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_raj_IN_u_nu_latn;
    break;
  case 'rm':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rm;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rm;
    break;
  case 'rm_CH':
  case 'rm-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rm_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rm_CH;
    break;
  case 'rn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rn;
    break;
  case 'rn_BI':
  case 'rn-BI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rn_BI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rn_BI;
    break;
  case 'ro_MD':
  case 'ro-MD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ro_MD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ro_MD;
    break;
  case 'ro_RO':
  case 'ro-RO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ro_RO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ro_RO;
    break;
  case 'rof':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rof;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rof;
    break;
  case 'rof_TZ':
  case 'rof-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rof_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rof_TZ;
    break;
  case 'ru_BY':
  case 'ru-BY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ru_BY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ru_BY;
    break;
  case 'ru_KG':
  case 'ru-KG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ru_KG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ru_KG;
    break;
  case 'ru_KZ':
  case 'ru-KZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ru_KZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ru_KZ;
    break;
  case 'ru_MD':
  case 'ru-MD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ru_MD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ru_MD;
    break;
  case 'ru_RU':
  case 'ru-RU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ru_RU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ru_RU;
    break;
  case 'ru_UA':
  case 'ru-UA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ru_UA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ru_UA;
    break;
  case 'rw':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rw;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rw;
    break;
  case 'rw_RW':
  case 'rw-RW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rw_RW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rw_RW;
    break;
  case 'rwk':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rwk;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rwk;
    break;
  case 'rwk_TZ':
  case 'rwk-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_rwk_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_rwk_TZ;
    break;
  case 'sa':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sa;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sa_u_nu_latn;
    break;
  case 'sa_IN':
  case 'sa-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sa_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sa_IN_u_nu_latn;
    break;
  case 'sah':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sah;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sah;
    break;
  case 'sah_RU':
  case 'sah-RU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sah_RU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sah_RU;
    break;
  case 'saq':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_saq;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_saq;
    break;
  case 'saq_KE':
  case 'saq-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_saq_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_saq_KE;
    break;
  case 'sat':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sat;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sat_u_nu_latn;
    break;
  case 'sat_Olck':
  case 'sat-Olck':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sat_Olck;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sat_Olck_u_nu_latn;
    break;
  case 'sat_Olck_IN':
  case 'sat-Olck-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sat_Olck_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sat_Olck_IN_u_nu_latn;
    break;
  case 'sbp':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sbp;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sbp;
    break;
  case 'sbp_TZ':
  case 'sbp-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sbp_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sbp_TZ;
    break;
  case 'sc':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sc;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sc;
    break;
  case 'sc_IT':
  case 'sc-IT':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sc_IT;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sc_IT;
    break;
  case 'sd':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sd;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_u_nu_latn;
    break;
  case 'sd_Arab':
  case 'sd-Arab':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sd_Arab;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_Arab_u_nu_latn;
    break;
  case 'sd_Arab_PK':
  case 'sd-Arab-PK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sd_Arab_PK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_Arab_PK_u_nu_latn;
    break;
  case 'sd_Deva':
  case 'sd-Deva':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sd_Deva;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_Deva;
    break;
  case 'sd_Deva_IN':
  case 'sd-Deva-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sd_Deva_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sd_Deva_IN;
    break;
  case 'se':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_se;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_se;
    break;
  case 'se_FI':
  case 'se-FI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_se_FI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_se_FI;
    break;
  case 'se_NO':
  case 'se-NO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_se_NO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_se_NO;
    break;
  case 'se_SE':
  case 'se-SE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_se_SE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_se_SE;
    break;
  case 'seh':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_seh;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_seh;
    break;
  case 'seh_MZ':
  case 'seh-MZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_seh_MZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_seh_MZ;
    break;
  case 'ses':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ses;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ses;
    break;
  case 'ses_ML':
  case 'ses-ML':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ses_ML;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ses_ML;
    break;
  case 'sg':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sg;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sg;
    break;
  case 'sg_CF':
  case 'sg-CF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sg_CF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sg_CF;
    break;
  case 'shi':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_shi;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_shi;
    break;
  case 'shi_Latn':
  case 'shi-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_shi_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_shi_Latn;
    break;
  case 'shi_Latn_MA':
  case 'shi-Latn-MA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_shi_Latn_MA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_shi_Latn_MA;
    break;
  case 'shi_Tfng':
  case 'shi-Tfng':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_shi_Tfng;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_shi_Tfng;
    break;
  case 'shi_Tfng_MA':
  case 'shi-Tfng-MA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_shi_Tfng_MA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_shi_Tfng_MA;
    break;
  case 'si_LK':
  case 'si-LK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_si_LK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_si_LK;
    break;
  case 'sk_SK':
  case 'sk-SK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sk_SK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sk_SK;
    break;
  case 'sl_SI':
  case 'sl-SI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sl_SI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sl_SI;
    break;
  case 'smn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_smn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_smn;
    break;
  case 'smn_FI':
  case 'smn-FI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_smn_FI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_smn_FI;
    break;
  case 'sn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sn;
    break;
  case 'sn_ZW':
  case 'sn-ZW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sn_ZW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sn_ZW;
    break;
  case 'so':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_so;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_so;
    break;
  case 'so_DJ':
  case 'so-DJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_so_DJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_so_DJ;
    break;
  case 'so_ET':
  case 'so-ET':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_so_ET;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_so_ET;
    break;
  case 'so_KE':
  case 'so-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_so_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_so_KE;
    break;
  case 'so_SO':
  case 'so-SO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_so_SO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_so_SO;
    break;
  case 'sq_AL':
  case 'sq-AL':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sq_AL;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sq_AL;
    break;
  case 'sq_MK':
  case 'sq-MK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sq_MK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sq_MK;
    break;
  case 'sq_XK':
  case 'sq-XK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sq_XK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sq_XK;
    break;
  case 'sr_Cyrl':
  case 'sr-Cyrl':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Cyrl;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Cyrl;
    break;
  case 'sr_Cyrl_BA':
  case 'sr-Cyrl-BA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Cyrl_BA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Cyrl_BA;
    break;
  case 'sr_Cyrl_ME':
  case 'sr-Cyrl-ME':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Cyrl_ME;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Cyrl_ME;
    break;
  case 'sr_Cyrl_RS':
  case 'sr-Cyrl-RS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Cyrl_RS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Cyrl_RS;
    break;
  case 'sr_Cyrl_XK':
  case 'sr-Cyrl-XK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Cyrl_XK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Cyrl_XK;
    break;
  case 'sr_Latn_BA':
  case 'sr-Latn-BA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Latn_BA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Latn_BA;
    break;
  case 'sr_Latn_ME':
  case 'sr-Latn-ME':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Latn_ME;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Latn_ME;
    break;
  case 'sr_Latn_RS':
  case 'sr-Latn-RS':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Latn_RS;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Latn_RS;
    break;
  case 'sr_Latn_XK':
  case 'sr-Latn-XK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sr_Latn_XK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sr_Latn_XK;
    break;
  case 'su':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_su;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_su;
    break;
  case 'su_Latn':
  case 'su-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_su_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_su_Latn;
    break;
  case 'su_Latn_ID':
  case 'su-Latn-ID':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_su_Latn_ID;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_su_Latn_ID;
    break;
  case 'sv_AX':
  case 'sv-AX':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sv_AX;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sv_AX;
    break;
  case 'sv_FI':
  case 'sv-FI':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sv_FI;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sv_FI;
    break;
  case 'sv_SE':
  case 'sv-SE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sv_SE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sv_SE;
    break;
  case 'sw_CD':
  case 'sw-CD':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sw_CD;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sw_CD;
    break;
  case 'sw_KE':
  case 'sw-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sw_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sw_KE;
    break;
  case 'sw_TZ':
  case 'sw-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sw_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sw_TZ;
    break;
  case 'sw_UG':
  case 'sw-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_sw_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_sw_UG;
    break;
  case 'ta_IN':
  case 'ta-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ta_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ta_IN;
    break;
  case 'ta_LK':
  case 'ta-LK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ta_LK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ta_LK;
    break;
  case 'ta_MY':
  case 'ta-MY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ta_MY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ta_MY;
    break;
  case 'ta_SG':
  case 'ta-SG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ta_SG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ta_SG;
    break;
  case 'te_IN':
  case 'te-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_te_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_te_IN;
    break;
  case 'teo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_teo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_teo;
    break;
  case 'teo_KE':
  case 'teo-KE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_teo_KE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_teo_KE;
    break;
  case 'teo_UG':
  case 'teo-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_teo_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_teo_UG;
    break;
  case 'tg':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tg;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tg;
    break;
  case 'tg_TJ':
  case 'tg-TJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tg_TJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tg_TJ;
    break;
  case 'th_TH':
  case 'th-TH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_th_TH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_th_TH;
    break;
  case 'ti':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ti;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ti;
    break;
  case 'ti_ER':
  case 'ti-ER':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ti_ER;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ti_ER;
    break;
  case 'ti_ET':
  case 'ti-ET':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ti_ET;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ti_ET;
    break;
  case 'tk':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tk;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tk;
    break;
  case 'tk_TM':
  case 'tk-TM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tk_TM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tk_TM;
    break;
  case 'to':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_to;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_to;
    break;
  case 'to_TO':
  case 'to-TO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_to_TO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_to_TO;
    break;
  case 'tr_CY':
  case 'tr-CY':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tr_CY;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tr_CY;
    break;
  case 'tr_TR':
  case 'tr-TR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tr_TR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tr_TR;
    break;
  case 'tt':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tt;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tt;
    break;
  case 'tt_RU':
  case 'tt-RU':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tt_RU;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tt_RU;
    break;
  case 'twq':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_twq;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_twq;
    break;
  case 'twq_NE':
  case 'twq-NE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_twq_NE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_twq_NE;
    break;
  case 'tzm':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tzm;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tzm;
    break;
  case 'tzm_MA':
  case 'tzm-MA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_tzm_MA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_tzm_MA;
    break;
  case 'ug':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ug;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ug;
    break;
  case 'ug_CN':
  case 'ug-CN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ug_CN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ug_CN;
    break;
  case 'uk_UA':
  case 'uk-UA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uk_UA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uk_UA;
    break;
  case 'ur_IN':
  case 'ur-IN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ur_IN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ur_IN_u_nu_latn;
    break;
  case 'ur_PK':
  case 'ur-PK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_ur_PK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_ur_PK;
    break;
  case 'uz_Arab':
  case 'uz-Arab':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uz_Arab;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uz_Arab_u_nu_latn;
    break;
  case 'uz_Arab_AF':
  case 'uz-Arab-AF':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uz_Arab_AF;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uz_Arab_AF_u_nu_latn;
    break;
  case 'uz_Cyrl':
  case 'uz-Cyrl':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uz_Cyrl;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uz_Cyrl;
    break;
  case 'uz_Cyrl_UZ':
  case 'uz-Cyrl-UZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uz_Cyrl_UZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uz_Cyrl_UZ;
    break;
  case 'uz_Latn':
  case 'uz-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uz_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uz_Latn;
    break;
  case 'uz_Latn_UZ':
  case 'uz-Latn-UZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_uz_Latn_UZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_uz_Latn_UZ;
    break;
  case 'vai':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vai;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vai;
    break;
  case 'vai_Latn':
  case 'vai-Latn':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vai_Latn;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vai_Latn;
    break;
  case 'vai_Latn_LR':
  case 'vai-Latn-LR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vai_Latn_LR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vai_Latn_LR;
    break;
  case 'vai_Vaii':
  case 'vai-Vaii':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vai_Vaii;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vai_Vaii;
    break;
  case 'vai_Vaii_LR':
  case 'vai-Vaii-LR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vai_Vaii_LR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vai_Vaii_LR;
    break;
  case 'vi_VN':
  case 'vi-VN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vi_VN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vi_VN;
    break;
  case 'vun':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vun;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vun;
    break;
  case 'vun_TZ':
  case 'vun-TZ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_vun_TZ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_vun_TZ;
    break;
  case 'wae':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_wae;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_wae;
    break;
  case 'wae_CH':
  case 'wae-CH':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_wae_CH;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_wae_CH;
    break;
  case 'wo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_wo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_wo;
    break;
  case 'wo_SN':
  case 'wo-SN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_wo_SN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_wo_SN;
    break;
  case 'xh':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_xh;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_xh;
    break;
  case 'xh_ZA':
  case 'xh-ZA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_xh_ZA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_xh_ZA;
    break;
  case 'xog':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_xog;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_xog;
    break;
  case 'xog_UG':
  case 'xog-UG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_xog_UG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_xog_UG;
    break;
  case 'yav':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yav;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yav;
    break;
  case 'yav_CM':
  case 'yav-CM':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yav_CM;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yav_CM;
    break;
  case 'yi':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yi;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yi;
    break;
  case 'yi_001':
  case 'yi-001':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yi_001;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yi_001;
    break;
  case 'yo':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yo;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yo;
    break;
  case 'yo_BJ':
  case 'yo-BJ':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yo_BJ;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yo_BJ;
    break;
  case 'yo_NG':
  case 'yo-NG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yo_NG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yo_NG;
    break;
  case 'yrl':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yrl;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yrl;
    break;
  case 'yrl_BR':
  case 'yrl-BR':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yrl_BR;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yrl_BR;
    break;
  case 'yrl_CO':
  case 'yrl-CO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yrl_CO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yrl_CO;
    break;
  case 'yrl_VE':
  case 'yrl-VE':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yrl_VE;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yrl_VE;
    break;
  case 'yue':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yue;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yue;
    break;
  case 'yue_Hans':
  case 'yue-Hans':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yue_Hans;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yue_Hans;
    break;
  case 'yue_Hans_CN':
  case 'yue-Hans-CN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yue_Hans_CN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yue_Hans_CN;
    break;
  case 'yue_Hant':
  case 'yue-Hant':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yue_Hant;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yue_Hant;
    break;
  case 'yue_Hant_HK':
  case 'yue-Hant-HK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_yue_Hant_HK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_yue_Hant_HK;
    break;
  case 'zgh':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zgh;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zgh;
    break;
  case 'zgh_MA':
  case 'zgh-MA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zgh_MA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zgh_MA;
    break;
  case 'zh_Hans':
  case 'zh-Hans':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hans;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hans;
    break;
  case 'zh_Hans_CN':
  case 'zh-Hans-CN':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hans_CN;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hans_CN;
    break;
  case 'zh_Hans_HK':
  case 'zh-Hans-HK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hans_HK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hans_HK;
    break;
  case 'zh_Hans_MO':
  case 'zh-Hans-MO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hans_MO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hans_MO;
    break;
  case 'zh_Hans_SG':
  case 'zh-Hans-SG':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hans_SG;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hans_SG;
    break;
  case 'zh_Hant':
  case 'zh-Hant':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hant;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hant;
    break;
  case 'zh_Hant_HK':
  case 'zh-Hant-HK':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hant_HK;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hant_HK;
    break;
  case 'zh_Hant_MO':
  case 'zh-Hant-MO':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hant_MO;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hant_MO;
    break;
  case 'zh_Hant_TW':
  case 'zh-Hant-TW':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zh_Hant_TW;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zh_Hant_TW;
    break;
  case 'zu_ZA':
  case 'zu-ZA':
    goog.i18n.NumberFormatSymbols = goog.i18n.NumberFormatSymbols_zu_ZA;
    goog.i18n.NumberFormatSymbols_u_nu_latn = goog.i18n.NumberFormatSymbols_zu_ZA;
    break;
}
